--
-- Schema generated by Libformed
-- Tue, 2022-07-26 17:13:45 +0000
-- # Revision: $Revision: f1588df74250 $
--
-- # tables: 16
--
BEGIN;
--
-- DROP TABLES
--
-- DROP TABLE nm_methode_tbl CASCADE;
-- DROP TABLE nm_format_tbl CASCADE;
-- DROP TABLE nm_inhalte_tbl CASCADE;
-- DROP TABLE nm_klassenstufen_tbl CASCADE;
-- DROP TABLE rg_gruppenangebote_tbl CASCADE;
-- DROP TABLE klassenstufe_5_tbl CASCADE;
-- DROP TABLE master_tbl CASCADE;
-- DROP TABLE phase_tbl CASCADE;
-- DROP TABLE schulform_tbl CASCADE;
-- DROP TABLE schriftliche_kooperationsvereinbarung_tbl CASCADE;
-- DROP TABLE klassenstufen_tbl CASCADE;
-- DROP TABLE inhalte_tbl CASCADE;
-- DROP TABLE format_tbl CASCADE;
-- DROP TABLE methode_tbl CASCADE;
-- DROP TABLE ort_gruppenangebot_tbl CASCADE;
-- DROP TABLE wie_gruppenangebot_tbl CASCADE;

--
-- CREATE TABLES
--
CREATE TABLE wie_gruppenangebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(31) NOT NULL
);
CREATE TABLE ort_gruppenangebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(67) NOT NULL
);
CREATE TABLE methode_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(83) NOT NULL
);
CREATE TABLE format_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(20) NOT NULL
);
CREATE TABLE inhalte_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(54) NOT NULL
);
CREATE TABLE klassenstufen_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);
CREATE TABLE schriftliche_kooperationsvereinbarung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(16) NOT NULL
);
CREATE TABLE schulform_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(48) NOT NULL
);
CREATE TABLE phase_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);
CREATE TABLE master_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    uuid_id CHAR(36),
    bearbeiter_id int NOT NULL,
    fkz VARCHAR(60),
    phase INTEGER DEFAULT -1,
    name_der_schule VARCHAR(60),
    schulform INTEGER DEFAULT -1,
    schulform_nennung_sonstige VARCHAR(60),
    schriftliche_kooperationsvereinbarung INTEGER DEFAULT -1,
    weitere_angaben_kooperationsvereinbarung TEXT,
    datum_begin_kooperation DATE,
    datum_ende_kooperation DATE,
    praeventionskonzept_vorhanden INTEGER DEFAULT -1,
    weitere_angaben_praeventionskonzept TEXT,
    UNIQUE (uuid_id),
    FOREIGN KEY (phase) REFERENCES phase_tbl (id),
    FOREIGN KEY (schulform) REFERENCES schulform_tbl (id),
    FOREIGN KEY (schriftliche_kooperationsvereinbarung) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id),
    FOREIGN KEY (praeventionskonzept_vorhanden) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id)
);
CREATE TABLE klassenstufe_5_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE rg_gruppenangebote_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    name_gruppenangebot VARCHAR(60),
    datum_start_gruppenangebot DATE,
    datum_ende_gruppenangebot DATE,
    anzahl_teilnehmer_maennlich INTEGER,
    anzahl_teilnehmer_weiblich INTEGER,
    anzahl_teilnehmer_divers INTEGER,
    inhalt_weitere_angaben TEXT,
    format_nennung_sonstiges VARCHAR(60),
    methode_weitere_angaben TEXT,
    ort_gruppenangebot INTEGER DEFAULT -1,
    wie_gruppenangebot INTEGER DEFAULT -1,
    anbieter_politische_bildung INTEGER DEFAULT -1,
    anbieter_extremismuspraevention INTEGER DEFAULT -1,
    anbieter_sonstiges INTEGER DEFAULT -1,
    anbieter_nennung_sonstiges VARCHAR(60),
    weitere_angaben_gruppenangebot TEXT,
    anzahl_individuelle_beratungen INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (ort_gruppenangebot) REFERENCES ort_gruppenangebot_tbl (id),
    FOREIGN KEY (wie_gruppenangebot) REFERENCES wie_gruppenangebot_tbl (id),
    FOREIGN KEY (anbieter_politische_bildung) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (anbieter_extremismuspraevention) REFERENCES klassenstufe_5_tbl (id),
    FOREIGN KEY (anbieter_sonstiges) REFERENCES klassenstufe_5_tbl (id)
);
CREATE TABLE nm_klassenstufen_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES klassenstufen_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_inhalte_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES inhalte_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_format_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES format_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);
CREATE TABLE nm_methode_tbl (
    rg_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_gruppenangebote_id) REFERENCES rg_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES methode_tbl (id),
    PRIMARY KEY (rg_gruppenangebote_id, choice_id)
);

--
-- INSERT DATA
--
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (-4, 'Keine Angabe weil Bestandsakte');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (1, 'Online');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (2, 'Vor Ort');
INSERT INTO wie_gruppenangebot_tbl (id, value) VALUES (3, 'Hybrid');

INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (1, 'In den Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (2, 'Außerhalb der Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (3, 'Teilweise in und teilweise außerhalb der Räumlichkeiten der Schule');

INSERT INTO methode_tbl (id, value) VALUES (1, 'Gruppendiskussion');
INSERT INTO methode_tbl (id, value) VALUES (2, 'Erlebnispädagogik (z.B. sportliche Aktivitäten)');
INSERT INTO methode_tbl (id, value) VALUES (3, 'Theaterpädagogik  ');
INSERT INTO methode_tbl (id, value) VALUES (4, 'Musikpädagogik (z.B. Rap)');
INSERT INTO methode_tbl (id, value) VALUES (5, 'Kunstpädagogik (z.B. Graffiti, Foto)');
INSERT INTO methode_tbl (id, value) VALUES (6, 'Medienpädagogik (z.B. Film, Radio, Soziale Medien)');
INSERT INTO methode_tbl (id, value) VALUES (7, 'Anti-Gewalt/ Anti-Konflikt Training');
INSERT INTO methode_tbl (id, value) VALUES (8, 'Multiplikator*innen-Ausbildung / Peer-to-Peer Ansatz (z.B. Streitschlichter*innen)');
INSERT INTO methode_tbl (id, value) VALUES (9, 'Planspiel');
INSERT INTO methode_tbl (id, value) VALUES (10, 'Museumspädagogik/Stadtführung ');
INSERT INTO methode_tbl (id, value) VALUES (11, 'Vortrag');

INSERT INTO format_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO format_tbl (id, value) VALUES (1, 'AG');
INSERT INTO format_tbl (id, value) VALUES (2, 'Ausflug');
INSERT INTO format_tbl (id, value) VALUES (3, 'Klassenfahrt');
INSERT INTO format_tbl (id, value) VALUES (4, 'Veranstaltung');
INSERT INTO format_tbl (id, value) VALUES (5, 'Veranstaltungsreihe');
INSERT INTO format_tbl (id, value) VALUES (6, 'Workshop');
INSERT INTO format_tbl (id, value) VALUES (7, 'Workshopreihe');

INSERT INTO inhalte_tbl (id, value) VALUES (1, 'Demokratiebildung');
INSERT INTO inhalte_tbl (id, value) VALUES (2, 'Stärkung der interkulturellen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (3, 'Stärkung der interreligiösen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (4, 'Geschlechter-Reflektierte Arbeit/ Rollenbilder');
INSERT INTO inhalte_tbl (id, value) VALUES (5, 'Stärkung der Selbstwirksamkeit');
INSERT INTO inhalte_tbl (id, value) VALUES (6, 'Stärkung der Sozialen Kompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (7, 'Stärkung der Medienkompetenz');
INSERT INTO inhalte_tbl (id, value) VALUES (8, 'Auseinandersetzung mit menschenfeindlichen Ideologien');
INSERT INTO inhalte_tbl (id, value) VALUES (9, 'Mobbing im religiösen Kontext');
INSERT INTO inhalte_tbl (id, value) VALUES (10, 'Auseinandersetzung mit Rechtsextremismus');

INSERT INTO klassenstufen_tbl (id, value) VALUES (5, '5');
INSERT INTO klassenstufen_tbl (id, value) VALUES (6, '6');
INSERT INTO klassenstufen_tbl (id, value) VALUES (7, '7');
INSERT INTO klassenstufen_tbl (id, value) VALUES (8, '8');
INSERT INTO klassenstufen_tbl (id, value) VALUES (9, '9');
INSERT INTO klassenstufen_tbl (id, value) VALUES (10, '10');
INSERT INTO klassenstufen_tbl (id, value) VALUES (11, '11');
INSERT INTO klassenstufen_tbl (id, value) VALUES (12, '12');
INSERT INTO klassenstufen_tbl (id, value) VALUES (13, '13');
INSERT INTO klassenstufen_tbl (id, value) VALUES (100, 'Berufliche Schule');

INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (0, 'Nein (Altdaten)');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (1, 'Ja');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (2, 'in Aussicht');

INSERT INTO schulform_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO schulform_tbl (id, value) VALUES (-2, 'sonstige Schule');
INSERT INTO schulform_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schulform_tbl (id, value) VALUES (1, 'Förderschule');
INSERT INTO schulform_tbl (id, value) VALUES (2, 'Hauptschule');
INSERT INTO schulform_tbl (id, value) VALUES (3, 'Realschule');
INSERT INTO schulform_tbl (id, value) VALUES (4, 'Schularten mit drei Bildungsgängen/Gesamtschule');
INSERT INTO schulform_tbl (id, value) VALUES (5, 'Gymnasium');
INSERT INTO schulform_tbl (id, value) VALUES (6, 'Berufsschule');
INSERT INTO schulform_tbl (id, value) VALUES (7, 'Berufsvorbereitungsjahr (BVJ)');
INSERT INTO schulform_tbl (id, value) VALUES (8, 'Berufsgrundbildungsjahr (BGJ)');
INSERT INTO schulform_tbl (id, value) VALUES (9, 'Berufskolleg');
INSERT INTO schulform_tbl (id, value) VALUES (10, 'Grundschule');
INSERT INTO schulform_tbl (id, value) VALUES (11, 'Schularten mit zwei Bildungsgängen');

INSERT INTO phase_tbl (id, value) VALUES (-1, 'Unbekannt');
INSERT INTO phase_tbl (id, value) VALUES (0, 'Erfassung läuft');
INSERT INTO phase_tbl (id, value) VALUES (1, 'Erfassung beendet');

INSERT INTO klassenstufe_5_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO klassenstufe_5_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO klassenstufe_5_tbl (id, value) VALUES (1, 'Ja');


--
-- GRANTS ON TABLES
--
GRANT SELECT ON wie_gruppenangebot_tbl TO GROUP :cm_group;
GRANT SELECT ON wie_gruppenangebot_tbl TO GROUP :admin_group;
GRANT SELECT ON ort_gruppenangebot_tbl TO GROUP :cm_group;
GRANT SELECT ON ort_gruppenangebot_tbl TO GROUP :admin_group;
GRANT SELECT ON methode_tbl TO GROUP :cm_group;
GRANT SELECT ON methode_tbl TO GROUP :admin_group;
GRANT SELECT ON format_tbl TO GROUP :cm_group;
GRANT SELECT ON format_tbl TO GROUP :admin_group;
GRANT SELECT ON inhalte_tbl TO GROUP :cm_group;
GRANT SELECT ON inhalte_tbl TO GROUP :admin_group;
GRANT SELECT ON klassenstufen_tbl TO GROUP :cm_group;
GRANT SELECT ON klassenstufen_tbl TO GROUP :admin_group;
GRANT SELECT ON schriftliche_kooperationsvereinbarung_tbl TO GROUP :cm_group;
GRANT SELECT ON schriftliche_kooperationsvereinbarung_tbl TO GROUP :admin_group;
GRANT SELECT ON schulform_tbl TO GROUP :cm_group;
GRANT SELECT ON schulform_tbl TO GROUP :admin_group;
GRANT SELECT ON phase_tbl TO GROUP :cm_group;
GRANT SELECT ON phase_tbl TO GROUP :admin_group;
GRANT SELECT ON klassenstufe_5_tbl TO GROUP :cm_group;
GRANT SELECT ON klassenstufe_5_tbl TO GROUP :admin_group;
--
--
-- views for master table and repeat groups
--
CREATE OR REPLACE VIEW master_tbl_view
AS SELECT 
     master_tbl.id AS id,
     master_tbl.uuid_id AS uuid_id,
     master_tbl.bearbeiter_id AS bearbeiter_id,
     master_tbl.fkz AS fkz,
     master_tbl.phase AS phase,
     master_tbl.name_der_schule AS name_der_schule,
     master_tbl.schulform AS schulform,
     master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
     master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
     master_tbl.weitere_angaben_kooperationsvereinbarung AS weitere_angaben_kooperationsvereinbarung,
     master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
     master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
     master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
     master_tbl.weitere_angaben_praeventionskonzept AS weitere_angaben_praeventionskonzept,
     ( COALESCE( (SELECT SUM( COALESCE( anzahl_individuelle_beratungen , 0 ) ) FROM rg_gruppenangebote_tbl rg WHERE rg.master_id = master_tbl.id ) , 0 ) ) as individuelle_beratungen_gesamt
FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD (
    UPDATE master_tbl SET
        phase = NEW.phase,
        name_der_schule = NEW.name_der_schule,
        schulform = NEW.schulform,
        schulform_nennung_sonstige = NEW.schulform_nennung_sonstige,
        schriftliche_kooperationsvereinbarung = NEW.schriftliche_kooperationsvereinbarung,
        weitere_angaben_kooperationsvereinbarung = NEW.weitere_angaben_kooperationsvereinbarung,
        datum_begin_kooperation = NEW.datum_begin_kooperation,
        datum_ende_kooperation = NEW.datum_ende_kooperation,
        praeventionskonzept_vorhanden = NEW.praeventionskonzept_vorhanden,
        weitere_angaben_praeventionskonzept = NEW.weitere_angaben_praeventionskonzept
    WHERE id = NEW.id;
);
CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    master_tbl.id AS id,
    NULL::CHAR(36) AS uuid_id,
    master_tbl.bearbeiter_id AS bearbeiter_id,
    master_tbl.fkz AS fkz,
    master_tbl.phase AS phase,
    master_tbl.name_der_schule AS name_der_schule,
    master_tbl.schulform AS schulform,
    master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
    master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
    NULL::TEXT AS weitere_angaben_kooperationsvereinbarung,
    master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
    master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
    master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
    NULL::TEXT AS weitere_angaben_praeventionskonzept,
    master_tbl.individuelle_beratungen_gesamt AS individuelle_beratungen_gesamt FROM master_tbl_view master_tbl
    INNER JOIN ka_status_tbl s ON master_tbl.id = s.master_id
    WHERE  s.status <> 3;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_view
AS SELECT 
     rg_gruppenangebote_tbl.id AS id,
     rg_gruppenangebote_tbl.master_id AS master_id,
     rg_gruppenangebote_tbl.uuid_id AS uuid_id,
     rg_gruppenangebote_tbl.name_gruppenangebot AS name_gruppenangebot,
     rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
     rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_divers AS anzahl_teilnehmer_divers,
     ARRAY(SELECT choice_id FROM nm_klassenstufen_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS klassenstufen,
     ARRAY(SELECT choice_id FROM nm_inhalte_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS inhalte,
     rg_gruppenangebote_tbl.inhalt_weitere_angaben AS inhalt_weitere_angaben,
     ARRAY(SELECT choice_id FROM nm_format_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS format,
     rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
     ARRAY(SELECT choice_id FROM nm_methode_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS methode,
     rg_gruppenangebote_tbl.methode_weitere_angaben AS methode_weitere_angaben,
     rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
     rg_gruppenangebote_tbl.wie_gruppenangebot AS wie_gruppenangebot,
     rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
     rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
     rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
     rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
     rg_gruppenangebote_tbl.weitere_angaben_gruppenangebot AS weitere_angaben_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen
FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_gruppenangebote_tbl_view
DO INSTEAD (
    UPDATE rg_gruppenangebote_tbl SET
        name_gruppenangebot = NEW.name_gruppenangebot,
        datum_start_gruppenangebot = NEW.datum_start_gruppenangebot,
        datum_ende_gruppenangebot = NEW.datum_ende_gruppenangebot,
        anzahl_teilnehmer_maennlich = NEW.anzahl_teilnehmer_maennlich,
        anzahl_teilnehmer_weiblich = NEW.anzahl_teilnehmer_weiblich,
        anzahl_teilnehmer_divers = NEW.anzahl_teilnehmer_divers,
        inhalt_weitere_angaben = NEW.inhalt_weitere_angaben,
        format_nennung_sonstiges = NEW.format_nennung_sonstiges,
        methode_weitere_angaben = NEW.methode_weitere_angaben,
        ort_gruppenangebot = NEW.ort_gruppenangebot,
        wie_gruppenangebot = NEW.wie_gruppenangebot,
        anbieter_politische_bildung = NEW.anbieter_politische_bildung,
        anbieter_extremismuspraevention = NEW.anbieter_extremismuspraevention,
        anbieter_sonstiges = NEW.anbieter_sonstiges,
        anbieter_nennung_sonstiges = NEW.anbieter_nennung_sonstiges,
        weitere_angaben_gruppenangebot = NEW.weitere_angaben_gruppenangebot,
        anzahl_individuelle_beratungen = NEW.anzahl_individuelle_beratungen
    WHERE id = NEW.id;
    DELETE FROM nm_klassenstufen_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.klassenstufen);
    INSERT INTO nm_klassenstufen_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM klassenstufen_tbl a
          WHERE a.id = ANY (new.klassenstufen)
            AND NOT a.id = ANY (old.klassenstufen);

    DELETE FROM nm_inhalte_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.inhalte);
    INSERT INTO nm_inhalte_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM inhalte_tbl a
          WHERE a.id = ANY (new.inhalte)
            AND NOT a.id = ANY (old.inhalte);

    DELETE FROM nm_format_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.format);
    INSERT INTO nm_format_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM format_tbl a
          WHERE a.id = ANY (new.format)
            AND NOT a.id = ANY (old.format);

    DELETE FROM nm_methode_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.methode);
    INSERT INTO nm_methode_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM methode_tbl a
          WHERE a.id = ANY (new.methode)
            AND NOT a.id = ANY (old.methode);
);
CREATE OR REPLACE RULE rg_gruppenangebote_tbl_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_anonym_view
AS SELECT
    rg_gruppenangebote_tbl.id AS id,
    rg_gruppenangebote_tbl.master_id AS master_id,
    NULL::CHAR(36) AS uuid_id,
    NULL::VARCHAR(60) AS name_gruppenangebot,
    rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
    rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_divers AS anzahl_teilnehmer_divers,
    ARRAY(SELECT choice_id FROM nm_klassenstufen_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS klassenstufen,
    ARRAY(SELECT choice_id FROM nm_inhalte_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS inhalte,
    rg_gruppenangebote_tbl.inhalt_weitere_angaben AS inhalt_weitere_angaben,
    ARRAY(SELECT choice_id FROM nm_format_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS format,
    rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
    ARRAY(SELECT choice_id FROM nm_methode_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS methode,
    rg_gruppenangebote_tbl.methode_weitere_angaben AS methode_weitere_angaben,
    rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
    rg_gruppenangebote_tbl.wie_gruppenangebot AS wie_gruppenangebot,
    rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
    rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
    rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
    rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
    NULL::TEXT AS weitere_angaben_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_klassenstufen_tbl_view
AS SELECT 
     nm_klassenstufen_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_klassenstufen_tbl.choice_id AS choice_id
FROM nm_klassenstufen_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_klassenstufen_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_klassenstufen_tbl_update_rule AS ON UPDATE TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_klassenstufen_tbl_delete_rule AS ON DELETE TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_insert_rule AS ON INSERT TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_klassenstufen_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_klassenstufen_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_klassenstufen_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_klassenstufen_tbl_anonym_view
AS SELECT
    nm_klassenstufen_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_klassenstufen_tbl.choice_id AS choice_id FROM nm_klassenstufen_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_klassenstufen_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_anonym_delete_rule AS ON DELETE TO nm_klassenstufen_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_anonym_insert_rule AS ON INSERT TO nm_klassenstufen_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_klassenstufen_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_klassenstufen_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_inhalte_tbl_view
AS SELECT 
     nm_inhalte_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_inhalte_tbl.choice_id AS choice_id
FROM nm_inhalte_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_inhalte_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_inhalte_tbl_update_rule AS ON UPDATE TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_inhalte_tbl_delete_rule AS ON DELETE TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_inhalte_tbl_insert_rule AS ON INSERT TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_inhalte_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_inhalte_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_inhalte_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_inhalte_tbl_anonym_view
AS SELECT
    nm_inhalte_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_inhalte_tbl.choice_id AS choice_id FROM nm_inhalte_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_inhalte_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_inhalte_tbl_anonym_delete_rule AS ON DELETE TO nm_inhalte_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_inhalte_tbl_anonym_insert_rule AS ON INSERT TO nm_inhalte_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_inhalte_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_inhalte_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_format_tbl_view
AS SELECT 
     nm_format_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_format_tbl.choice_id AS choice_id
FROM nm_format_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_format_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_format_tbl_update_rule AS ON UPDATE TO nm_format_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_format_tbl_delete_rule AS ON DELETE TO nm_format_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_format_tbl_insert_rule AS ON INSERT TO nm_format_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_format_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_format_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_format_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_format_tbl_anonym_view
AS SELECT
    nm_format_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_format_tbl.choice_id AS choice_id FROM nm_format_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_format_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_format_tbl_anonym_delete_rule AS ON DELETE TO nm_format_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_format_tbl_anonym_insert_rule AS ON INSERT TO nm_format_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_format_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_format_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_methode_tbl_view
AS SELECT 
     nm_methode_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_methode_tbl.choice_id AS choice_id
FROM nm_methode_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_methode_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_methode_tbl_update_rule AS ON UPDATE TO nm_methode_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_methode_tbl_delete_rule AS ON DELETE TO nm_methode_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_methode_tbl_insert_rule AS ON INSERT TO nm_methode_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_methode_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_methode_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_methode_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_methode_tbl_anonym_view
AS SELECT
    nm_methode_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_methode_tbl.choice_id AS choice_id FROM nm_methode_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_methode_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_methode_tbl_anonym_delete_rule AS ON DELETE TO nm_methode_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_methode_tbl_anonym_insert_rule AS ON INSERT TO nm_methode_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_methode_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_methode_tbl_anonym_view TO GROUP :admin_group;

--
-- Function to anonymize a case and all of its repeat groups
--
CREATE OR REPLACE FUNCTION anonymize_case(mid int)
RETURNS void AS
$$
BEGIN
    PERFORM anonymize_uuid(mid);
    -- anonymize master table
    UPDATE master_tbl_view SET
        uuid_id = NULL,
        weitere_angaben_kooperationsvereinbarung = NULL,
        weitere_angaben_praeventionskonzept = NULL
    WHERE id = mid;

    -- anonymize repeat groups
    UPDATE rg_gruppenangebote_tbl_view SET
        uuid_id = NULL,
        name_gruppenangebot = NULL,
        weitere_angaben_gruppenangebot = NULL
    WHERE master_id = mid;

END;
$$ LANGUAGE plpgsql VOLATILE SECURITY DEFINER;

REVOKE ALL ON FUNCTION anonymize_case(int) FROM public;
GRANT EXECUTE ON FUNCTION anonymize_case(int) TO GROUP :admin_group;

COMMIT;
