-- Search for duplicate cases

-- Need to be postgres to create extension.
SET ROLE postgres;

CREATE EXTENSION pg_trgm;

-- Rest as mpuls admin
SET ROLE :adm_ka_owner;

-- DROP TYPE duplicate_case;
CREATE TYPE duplicate_case AS (
    id INTEGER,
    name VARCHAR,
    vorname VARCHAR,
    bearbeiter TEXT
);

-- DROP FUNCTION find_similar_cases(TEXT, TEXT);
CREATE OR REPLACE FUNCTION find_similar_cases(new_name TEXT, new_vorname TEXT)
    RETURNS SETOF duplicate_case
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
BEGIN
    RETURN QUERY
    SELECT m.id, m.name, m.vorname, b.nachname || ', ' || b.vorname
      FROM master_tbl m
      JOIN ka_benutzer_tbl_view b ON m.bearbeiter_id = b.id
     WHERE m.name % new_name AND m.vorname % new_vorname;
END;
$$ ;
