BEGIN;
--
--
-- CREATE TABLES
--
CREATE TABLE dbinfo (
    id INTEGER PRIMARY KEY NOT NULL,
    key   VARCHAR(128) NOT NULL,
    value VARCHAR(256) 
);

INSERT INTO dbinfo (id, key, value) VALUES (1, 'version', CURRENT_TIME);
INSERT INTO dbinfo (id, key, value) VALUES (2, 'datadump', NULL);

CREATE TABLE bundeslaender_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    name VARCHAR(256) NOT NULL UNIQUE,
    kurz CHAR(2) NOT NULL UNIQUE
);

INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (-1, 'keine Angabe', '');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 0, 'Baden-Württemberg', 'BW');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 1, 'Bayern', 'BY');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 2, 'Berlin', 'BE');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 3, 'Brandenburg', 'BB');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 4, 'Bremen', 'HB');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 5, 'Hamburg', 'HH');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 6, 'Hessen', 'HE');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 7, 'Mecklenburg-Vorpommern', 'MV');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 8, 'Niedersachsen', 'NI');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES ( 9, 'Nordrhein-Westfalen', 'NW');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (10, 'Rheinland-Pfalz', 'RP');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (11, 'Saarland', 'SL');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (12, 'Sachsen', 'SN');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (13, 'Sachsen-Anhalt', 'ST');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (14, 'Schleswig-Holstein', 'SH');
INSERT INTO bundeslaender_tbl (id, name, kurz) VALUES (15, 'Thüringen', 'TH');

CREATE TABLE fkz_tbl (
    id            INTEGER PRIMARY KEY NOT NULL,
    name          VARCHAR(256) NOT NULL,
    fkz           VARCHAR(256) NOT NULL UNIQUE,
    database      VARCHAR(256) NOT NULL UNIQUE,
    bundesland_id INTEGER NOT NULL REFERENCES bundeslaender_tbl(id),
    UNIQUE (fkz, database)
);

-- -- --
-- -- -- START Autogenerated CREATE part of sql statements
-- -- -- (mastert_tbl...)
-- -- --
-- -- --

--
-- CREATE TABLES
--
CREATE TABLE weiter_akt_art_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(39) NOT NULL
);
CREATE TABLE mikroprojekt_format_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(26) NOT NULL
);
CREATE TABLE mikroprojekt_handlungsfeld_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(70) NOT NULL
);
CREATE TABLE nichtkjp_grp_art_angebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(51) NOT NULL
);
CREATE TABLE kjp_grp_ort_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE kjp_alter_tbl (
    id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(17) NOT NULL
);
CREATE TABLE kjp_grp_dauer_einheit_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(22) NOT NULL
);
CREATE TABLE kjp_grp_art_angebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(65) NOT NULL
);
CREATE TABLE gesamtbewertung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(17) NOT NULL
);
CREATE TABLE kontaktform_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE jmd_nimmt_an_verstaltungen_teil_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(15) NOT NULL
);
CREATE TABLE jmd_erreicht_andere_durchfuehrung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(22) NOT NULL
);
CREATE TABLE rg_koop_bewertungen_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(83) NOT NULL
);
CREATE TABLE rg_koop_5_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(76) NOT NULL
);
CREATE TABLE rg_koop_4_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(63) NOT NULL
);
CREATE TABLE rg_koop_3_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(35) NOT NULL
);
CREATE TABLE rg_koop_2_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(71) NOT NULL
);
CREATE TABLE rg_koop_1_institution_art_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(83) NOT NULL
);
CREATE TABLE beteiligung_integrationskonzepte_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(21) NOT NULL
);
CREATE TABLE mitarbeit_netzwerk_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(34) NOT NULL
);
CREATE TABLE zielgruppen_netzwerk_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(67) NOT NULL
);
CREATE TABLE bildungsberatung_garantiefonds_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE traeger_integrationskurs_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE jmdstruktur_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(26) NOT NULL
);
CREATE TABLE raeumliche_zustaendigkeit_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(58) NOT NULL
);
CREATE TABLE entstand_aus_kopie_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE phase_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);
CREATE TABLE master_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    uuid_id CHAR(36),
    bearbeiter_id int NOT NULL,
    fkz VARCHAR(60),
    phase INTEGER DEFAULT -1,
    entstand_aus_kopie INTEGER DEFAULT -1,
    jmd_iq INTEGER DEFAULT -1,
    kopie_geprueft_p_0 INTEGER DEFAULT -1,
    datum_begin_zeitraum DATE,
    datum_ende_zeitraum DATE,
    raeumliche_zustaendigkeit INTEGER DEFAULT -1,
    raeumliche_zustaendigkeit_nennung VARCHAR(60),
    nennung_zustaendigkeit TEXT,
    jmdstruktur INTEGER DEFAULT -1,
    traeger_integrationskurs INTEGER DEFAULT -1,
    kopie_geprueft_p_1 INTEGER DEFAULT -1,
    anzahl_ha_stellenteile NUMERIC,
    anzahl_ha_personen INTEGER,
    anzahl_ha_migration INTEGER,
    anzahl_ha_maennlich INTEGER,
    anzahl_ha_weiblich INTEGER,
    anzahl_ha_divers INTEGER,
    ha_sprachkenntnis_arabisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_englisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_franzoesisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_polnisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_russisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_spanisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_tuerkisch INTEGER DEFAULT -1,
    ha_sprachkenntnis_sonstige INTEGER DEFAULT -1,
    ha_sprachkenntnisse_sonstige_nennung VARCHAR(60),
    verteilung_aa_begleitung_cm INTEGER,
    verteilung_aa_beratung INTEGER,
    verteilung_aa_gruppenangebote INTEGER,
    verteilung_aa_netzwerkarbeit INTEGER,
    verteilung_aa_dokumentation INTEGER,
    verteilung_aa_elternarbeit INTEGER,
    verteilung_aa_sonstiges INTEGER,
    verteilung_aa_sonstiges_nennung TEXT,
    anzahl_nha_stellenteile NUMERIC,
    anzahl_nha_personen INTEGER,
    anzahl_nha_migration INTEGER,
    anzahl_nha_maennlich INTEGER,
    anzahl_nha_weiblich INTEGER,
    anzahl_nha_divers INTEGER,
    anzahl_nha_stundenunfang VARCHAR(6),
    anzahl_ea_personen INTEGER,
    anzahl_ea_migration INTEGER,
    anzahl_ea_maennlich INTEGER,
    anzahl_ea_weiblich INTEGER,
    anzahl_ea_divers INTEGER,
    bildungsberatung_garantiefonds INTEGER DEFAULT -1,
    bildungsberatung_beratungsfaelle INTEGER,
    kopie_geprueft_p_9 INTEGER DEFAULT -1,
    existenz_jugendhilfekonferenz INTEGER DEFAULT -1,
    teilnahme_jugenhilfekonferenz INTEGER DEFAULT -1,
    existenz_jugendkonferenz INTEGER DEFAULT -1,
    teilnahme_jugenkonferenz INTEGER DEFAULT -1,
    erstellung_netzwerkkarte INTEGER DEFAULT -1,
    mitarbeit_gremien TEXT,
    kopie_geprueft_p_6 INTEGER DEFAULT -1,
    kopie_geprueft_p_4 INTEGER DEFAULT -1,
    weitere_akt_anzahl_informationsveranst INTEGER,
    weitere_akt_anzahl_workshops INTEGER,
    weitere_akt_anzahl_trainings INTEGER,
    weitere_akt_anzahl_veroeffentlichungen INTEGER,
    weitere_akt_anzahl_referate INTEGER,
    weitere_akt_anzahl_sonstiges INTEGER,
    elternberatung_anzahl INTEGER,
    elternberatung_stunden INTEGER,
    weitere_akt_weitere_angaben TEXT,
    eingabe_vollstaendig INTEGER DEFAULT -1,
    UNIQUE (uuid_id),
    FOREIGN KEY (phase) REFERENCES phase_tbl (id),
    FOREIGN KEY (entstand_aus_kopie) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (jmd_iq) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (kopie_geprueft_p_0) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (raeumliche_zustaendigkeit) REFERENCES raeumliche_zustaendigkeit_tbl (id),
    FOREIGN KEY (jmdstruktur) REFERENCES jmdstruktur_tbl (id),
    FOREIGN KEY (traeger_integrationskurs) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (kopie_geprueft_p_1) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_arabisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_englisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_franzoesisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_polnisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_russisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_spanisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_tuerkisch) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (ha_sprachkenntnis_sonstige) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (bildungsberatung_garantiefonds) REFERENCES bildungsberatung_garantiefonds_tbl (id),
    FOREIGN KEY (kopie_geprueft_p_9) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (existenz_jugendhilfekonferenz) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (teilnahme_jugenhilfekonferenz) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (existenz_jugendkonferenz) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (teilnahme_jugenkonferenz) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (erstellung_netzwerkkarte) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (kopie_geprueft_p_6) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (kopie_geprueft_p_4) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (eingabe_vollstaendig) REFERENCES entstand_aus_kopie_tbl (id)
);
CREATE TABLE rg_netzwerk_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kopie_geprueft_p_5 INTEGER DEFAULT -1,
    zielgruppen_netzwerk INTEGER DEFAULT -1,
    zielgruppen_netzwerk_nennung VARCHAR(180),
    mitarbeit_netzwerk INTEGER DEFAULT -1,
    mitarbeit_netzwerk_erlaueterung VARCHAR(60),
    beteiligung_integrationskonzepte INTEGER DEFAULT -1,
    beteiligung_integrationskonzepte_erlaeuterung TEXT,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kopie_geprueft_p_5) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (zielgruppen_netzwerk) REFERENCES zielgruppen_netzwerk_tbl (id),
    FOREIGN KEY (mitarbeit_netzwerk) REFERENCES mitarbeit_netzwerk_tbl (id),
    FOREIGN KEY (beteiligung_integrationskonzepte) REFERENCES beteiligung_integrationskonzepte_tbl (id)
);
CREATE TABLE rg_koop_1_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_1_institution_art INTEGER DEFAULT -1,
    rg_koop_1_anzahl INTEGER,
    rg_koop_1_partner INTEGER,
    rg_koop_1_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_1_institution_art) REFERENCES rg_koop_1_institution_art_tbl (id)
);
CREATE UNIQUE INDEX rg_koop_1_tbl_unique_rg_koop_1_institution_art ON rg_koop_1_tbl (master_id, rg_koop_1_institution_art) WHERE (rg_koop_1_institution_art >= 0);
CREATE TABLE rg_koop_2_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_2_institution_art INTEGER DEFAULT -1,
    rg_koop_2_anzahl INTEGER,
    rg_koop_2_partner INTEGER,
    rg_koop_2_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_2_institution_art) REFERENCES rg_koop_2_institution_art_tbl (id)
);
CREATE UNIQUE INDEX rg_koop_2_tbl_unique_rg_koop_2_institution_art ON rg_koop_2_tbl (master_id, rg_koop_2_institution_art) WHERE (rg_koop_2_institution_art >= 0);
CREATE TABLE rg_koop_3_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_3_institution_art INTEGER DEFAULT -1,
    rg_koop_3_anzahl INTEGER,
    rg_koop_3_partner INTEGER,
    rg_koop_3_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_3_institution_art) REFERENCES rg_koop_3_institution_art_tbl (id)
);
CREATE UNIQUE INDEX rg_koop_3_tbl_unique_rg_koop_3_institution_art ON rg_koop_3_tbl (master_id, rg_koop_3_institution_art) WHERE (rg_koop_3_institution_art >= 0);
CREATE TABLE rg_koop_4_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_4_institution_art INTEGER DEFAULT -1,
    rg_koop_4_anzahl INTEGER,
    rg_koop_4_partner INTEGER,
    rg_koop_4_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_4_institution_art) REFERENCES rg_koop_4_institution_art_tbl (id)
);
CREATE UNIQUE INDEX rg_koop_4_tbl_unique_rg_koop_4_institution_art ON rg_koop_4_tbl (master_id, rg_koop_4_institution_art) WHERE (rg_koop_4_institution_art >= 0);
CREATE TABLE rg_koop_5_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    rg_koop_5_institution_art INTEGER DEFAULT -1,
    rg_koop_5_anzahl INTEGER,
    rg_koop_5_partner INTEGER,
    rg_koop_5_schriftlich INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (rg_koop_5_institution_art) REFERENCES rg_koop_5_institution_art_tbl (id)
);
CREATE UNIQUE INDEX rg_koop_5_tbl_unique_rg_koop_5_institution_art ON rg_koop_5_tbl (master_id, rg_koop_5_institution_art) WHERE (rg_koop_5_institution_art >= 0);
CREATE TABLE rg_koop_bewertungen_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kopie_geprueft_p_11 INTEGER DEFAULT -1,
    rg_koop_bewertungen_institution_art INTEGER DEFAULT -1,
    institution_unterstuetzt_aktiv INTEGER DEFAULT -1,
    jmd_erreicht_andere_durchfuehrung INTEGER DEFAULT -1,
    jmd_hat_einfluss_teilnehmer INTEGER DEFAULT -1,
    institution_legt_infomaterial INTEGER DEFAULT -1,
    institution_zufuehrung_menschen INTEGER DEFAULT -1,
    besteht_informationsaustausch INTEGER DEFAULT -1,
    besteht_regelmaessiger_austausch_fallbezogen INTEGER DEFAULT -1,
    besteht_regelmaessiger_austausch_nichtfallbezogen INTEGER DEFAULT -1,
    besteht_abstimmung_integrationsfp INTEGER DEFAULT -1,
    besteht_planung_veranstaltung INTEGER DEFAULT -1,
    besteht_gemeinsame_oeffentlichkeitsarbeit INTEGER DEFAULT -1,
    kontakt_besteht_ueber_gremien INTEGER DEFAULT -1,
    jmd_nimmt_an_verstaltungen_teil INTEGER DEFAULT -1,
    jmd_fuehrt_beratung_durch INTEGER DEFAULT -1,
    kooperation_schriftlich_festgelegt INTEGER DEFAULT -1,
    jmd_als_partner_auf_augenhoehe INTEGER DEFAULT -1,
    kontaktform INTEGER DEFAULT -1,
    gesamtbewertung INTEGER DEFAULT -1,
    nennung_besonderheiten_zusammenarbeit TEXT,
    nennung_erfahrungen_zusammenarbeit TEXT,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kopie_geprueft_p_11) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (rg_koop_bewertungen_institution_art) REFERENCES rg_koop_bewertungen_institution_art_tbl (id),
    FOREIGN KEY (institution_unterstuetzt_aktiv) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (jmd_erreicht_andere_durchfuehrung) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (jmd_hat_einfluss_teilnehmer) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (institution_legt_infomaterial) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (institution_zufuehrung_menschen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_informationsaustausch) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (besteht_regelmaessiger_austausch_fallbezogen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_regelmaessiger_austausch_nichtfallbezogen) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_abstimmung_integrationsfp) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_planung_veranstaltung) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (besteht_gemeinsame_oeffentlichkeitsarbeit) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (kontakt_besteht_ueber_gremien) REFERENCES traeger_integrationskurs_tbl (id),
    FOREIGN KEY (jmd_nimmt_an_verstaltungen_teil) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (jmd_fuehrt_beratung_durch) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (kooperation_schriftlich_festgelegt) REFERENCES jmd_nimmt_an_verstaltungen_teil_tbl (id),
    FOREIGN KEY (jmd_als_partner_auf_augenhoehe) REFERENCES jmd_erreicht_andere_durchfuehrung_tbl (id),
    FOREIGN KEY (kontaktform) REFERENCES kontaktform_tbl (id),
    FOREIGN KEY (gesamtbewertung) REFERENCES gesamtbewertung_tbl (id)
);
CREATE TABLE rg_kjp_gruppenangebote_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kopie_geprueft_p_2 INTEGER DEFAULT -1,
    kjp_grp_name VARCHAR(60),
    kjp_grp_art_angebot INTEGER DEFAULT -1,
    kjp_grp_dauer_stunden NUMERIC,
    kjp_grp_dauer_einheit INTEGER DEFAULT 0,
    kjp_grp_anzahl_teilnehmer_maennlich INTEGER,
    kjp_grp_anzahl_teilnehmer_weiblich INTEGER,
    kjp_grp_anzahl_teilnehmer_divers INTEGER,
    kjp_grp_ort INTEGER DEFAULT -1,
    kjp_grp_weitere_angaben TEXT,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kopie_geprueft_p_2) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (kjp_grp_art_angebot) REFERENCES kjp_grp_art_angebot_tbl (id),
    FOREIGN KEY (kjp_grp_dauer_einheit) REFERENCES kjp_grp_dauer_einheit_tbl (id),
    FOREIGN KEY (kjp_grp_ort) REFERENCES kjp_grp_ort_tbl (id)
);
CREATE TABLE nm_kjp_alter_tbl (
    rg_kjp_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_kjp_gruppenangebote_id) REFERENCES rg_kjp_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES kjp_alter_tbl (id),
    PRIMARY KEY (rg_kjp_gruppenangebote_id, choice_id)
);
CREATE TABLE rg_nichtkjp_gruppenangebote_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kopie_geprueft_p_3 INTEGER DEFAULT -1,
    nichtkjp_grp_name VARCHAR(60),
    nichtkjp_grp_art_angebot INTEGER DEFAULT -1,
    nichtkjp_grp_dauer_stunden NUMERIC,
    nichtkjp_grp_dauer_einheit INTEGER DEFAULT 0,
    nichtkjp_grp_anzahl_teilnehmer_maennlich INTEGER,
    nichtkjp_grp_anzahl_teilnehmer_weiblich INTEGER,
    nichtkjp_grp_anzahl_teilnehmer_divers INTEGER,
    nichtkjp_grp_ort INTEGER DEFAULT -1,
    nichtkjp_grp_weitere_angaben TEXT,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kopie_geprueft_p_3) REFERENCES entstand_aus_kopie_tbl (id),
    FOREIGN KEY (nichtkjp_grp_art_angebot) REFERENCES nichtkjp_grp_art_angebot_tbl (id),
    FOREIGN KEY (nichtkjp_grp_dauer_einheit) REFERENCES kjp_grp_dauer_einheit_tbl (id),
    FOREIGN KEY (nichtkjp_grp_ort) REFERENCES kjp_grp_ort_tbl (id)
);
CREATE TABLE nm_nichtkjp_alter_tbl (
    rg_nichtkjp_gruppenangebote_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_nichtkjp_gruppenangebote_id) REFERENCES rg_nichtkjp_gruppenangebote_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES kjp_alter_tbl (id),
    PRIMARY KEY (rg_nichtkjp_gruppenangebote_id, choice_id)
);
CREATE TABLE rg_jmd_iq_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    kopie_geprueft_p_iq INTEGER DEFAULT -1,
    name_mikroprojekt VARCHAR(60),
    kurzbeschreibung_mikroprojekt TEXT,
    datum_beginn_mikroprojekt DATE,
    datum_ende_mikroprojekt DATE,
    anzahl_iq_teilnehmende_direkt_maennlich INTEGER,
    anzahl_iq_teilnehmende_direkt_weiblich INTEGER,
    anzahl_iq_teilnehmende_direkt_divers INTEGER,
    anzahl_iq_teilnehmende_indirekt INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (kopie_geprueft_p_iq) REFERENCES entstand_aus_kopie_tbl (id)
);
CREATE TABLE nm_mikroprojekt_handlungsfeld_tbl (
    rg_jmd_iq_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_jmd_iq_id) REFERENCES rg_jmd_iq_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES mikroprojekt_handlungsfeld_tbl (id),
    PRIMARY KEY (rg_jmd_iq_id, choice_id)
);
CREATE TABLE nm_mikroprojekt_format_tbl (
    rg_jmd_iq_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (rg_jmd_iq_id) REFERENCES rg_jmd_iq_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES mikroprojekt_format_tbl (id),
    PRIMARY KEY (rg_jmd_iq_id, choice_id)
);
CREATE TABLE nm_weiter_akt_art_tbl (
    master_id INTEGER NOT NULL,
    choice_id int4 NOT NULL,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    FOREIGN KEY (choice_id) REFERENCES weiter_akt_art_tbl (id),
    PRIMARY KEY (master_id, choice_id)
);

--
-- INSERT DATA
--
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (1, 'interkulturelle Öffnung');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (2, 'aufsuchende Arbeit');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (3, 'Elternberatung');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (4, 'Förderung des freiwilligen Engagements');
INSERT INTO weiter_akt_art_tbl (id, value) VALUES (5, 'keine weitere Aktivität');

INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (1, 'AG');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (2, 'Ausflug');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (3, 'Veranstaltung');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (4, 'Stadt- oder Quartiersfest');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (5, 'Veranstaltungsreihe');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (6, 'Workshop');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (7, 'Workshopreihe');
INSERT INTO mikroprojekt_format_tbl (id, value) VALUES (8, 'Onlineformat');

INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (1, 'Bildung');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (2, 'Sprache');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (3, 'Arbeitsmarkt, Ausbildung und Armutsprävention');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (4, 'Verbraucherschutz');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (5, 'Gesundheit und Prävention');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (6, 'Unterstützung partizipativer Projekte von jungen Menschen im Quartier');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (7, 'Antirassismusarbeit und Demokratieförderung');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (8, 'Kultur');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (9, 'Sport');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (10, 'Umwelt und Mobilität');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (11, 'Wohnen und Wohnumfeld');
INSERT INTO mikroprojekt_handlungsfeld_tbl (id, value) VALUES (12, 'Interkulturelle Öffnung');

INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (0, 'freizeitpädagogische Angebote');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (1, 'Zusammenführung mit gleichaltrigen jungen Menschen');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (3, 'außerschulische Fördermaßnahmen');
INSERT INTO nichtkjp_grp_art_angebot_tbl (id, value) VALUES (4, 'Vermittlung in Hilfen nach SGB VIII');

INSERT INTO kjp_grp_ort_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO kjp_grp_ort_tbl (id, value) VALUES (1, 'Online');
INSERT INTO kjp_grp_ort_tbl (id, value) VALUES (2, 'Vor ort');
INSERT INTO kjp_grp_ort_tbl (id, value) VALUES (3, 'Hybrid');

INSERT INTO kjp_alter_tbl (id, value) VALUES (1, '12 bis 14 Jahre ');
INSERT INTO kjp_alter_tbl (id, value) VALUES (2, '15 bis 18 Jahre ');
INSERT INTO kjp_alter_tbl (id, value) VALUES (3, '19 bis 27 Jahre ');

INSERT INTO kjp_grp_dauer_einheit_tbl (id, value) VALUES (0, 'Zeitstunden (60min)');
INSERT INTO kjp_grp_dauer_einheit_tbl (id, value) VALUES (1, 'Doppelstunden (90min)');

INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (0, 'Orientierungshilfen zu gesellschaftlichen und politischen Themen');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (1, 'Orientierungshilfen im Bildungs- und Ausbildungssystem');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (3, 'Ergänzendes Sprach- und Kommunikationstraining');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (4, 'IT-Seminare/Medienpädagogik');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (5, 'Beratung und Informationen zu weiteren Maßnahmen');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (6, 'Training sozialer Kompetenzen');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (7, 'Elternarbeit');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (8, 'Qualifizierungsangebote im Rahmen der Freiwilligenarbeit');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (9, 'Stärkung der Persönlichkeit und Selbstwirksamkeitstraining');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (10, 'Gesundheitsförderung');
INSERT INTO kjp_grp_art_angebot_tbl (id, value) VALUES (11, 'Zugang zu Sport, politischer Bildung und Kulturangeboten');

INSERT INTO gesamtbewertung_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (1, 'sehr gut (1)');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (2, 'gut (2)');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (3, 'befriedigend (3)');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (4, 'ausreichend (4)');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (5, 'mangelhaft (5)');
INSERT INTO gesamtbewertung_tbl (id, value) VALUES (6, 'ungenügend (6)');

INSERT INTO kontaktform_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO kontaktform_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO kontaktform_tbl (id, value) VALUES (0, 'Persönlich');
INSERT INTO kontaktform_tbl (id, value) VALUES (1, 'Telefon');
INSERT INTO kontaktform_tbl (id, value) VALUES (2, 'Email');

INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (1, 'Ja');
INSERT INTO jmd_nimmt_an_verstaltungen_teil_tbl (id, value) VALUES (2, 'nicht relevant');

INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (0, 'trifft nicht zu');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (1, 'trifft teilweise zu');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (2, 'trifft überwiegend zu');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (4, 'trifft voll zu');
INSERT INTO jmd_erreicht_andere_durchfuehrung_tbl (id, value) VALUES (5, 'nicht relevant');

INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (0, 'Jugendamt ');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (1, 'Einrichtungen der schulbezogenen Jugendsozialarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (2, 'Ausbildungszentren / Jugendwerkstätten');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (3, 'Einrichtungen für berufsvorbereitende Maßnahmen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (4, 'Einrichtungen für berufsbegleitende Maßnahmen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (5, 'Beratungsstellen der öffentlichen  Jugendhilfe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (6, 'Einrichtungen der Heimerziehung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (7, 'Jugendgerichtshilfe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (8, 'Jugendzentren / offene Jugendarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (9, 'STÄRKEN vor Ort (alt)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (10, 'Kompetenzagenturen (alt)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (11, 'Koordinierungsstelle Schulverweigerung – Die 2. Chance (alt)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (13, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (14, 'Jugendmigrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (15, 'Kommunale Migrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (16, 'Migrationsberatung (MBE)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (17, 'anderweitig geförderte Erwachsenenmigrationsdienste');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (18, 'Übergangswohnheime / Gemeinschaftsunterkünfte / Aufnahmeeinrichtungen ');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (19, 'Interkulturelle Zentren / Vereine');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (20, 'Integrationskursträger');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (21, 'Integrations-, Aussiedler*innen-, Ausländer*innenbeautragte*r');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (22, 'Kommunale Referate für Integrationsfragen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (23, 'Kompetenzzentrum für Integration (NRW)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (24, 'Fördereinrichtungen für schulpflichtige Migrant*en*innen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (25, 'Vereine von Migrant*en*innen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (26, 'Länderspezifische Integrationsangebote');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (27, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (28, 'Allgemeinbildende Schulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (29, 'Weiterführende Schulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (30, 'Berufliche Schulen / Berufsschulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (31, 'Schulamt / Schulverwaltung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (32, 'Schulsozialarbeit');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (33, 'Schulpsychologischer Dienst');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (34, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (35, 'Jobcenter');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (36, 'Ausländerbehörde');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (37, 'Ausgleichsamt / Vertriebenenamt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (38, 'Sozialamt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (39, 'Gesundheitsamt / Krankenhäuser / Ärzte');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (40, 'Stadtverwaltung / Gemeindeverwaltung / Bürgeramt / Meldestelle');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (41, 'Kreisverwaltung / Landratsamt / Regierungsbezirke');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (42, 'Polizei');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (43, 'Regionalkoordinator*en*innen des BAMF');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (44, 'Jugendstrafanstalt');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (45, 'Sonstige');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (46, 'Arbeitgeber*innen / Betriebe');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (47, 'Handwerks-/ Industrie- und Handelskammer');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (48, 'Bildungsträger für Aus- und Weiterbildung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (49, 'Träger der politischen Bildung');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (50, 'Begegnungsstätten / Kulturzentren');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (51, 'Kirchengemeinden');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (52, 'Medien (Presse, Funk und Fernsehen)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (53, 'Stiftungen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (54, 'Selbsthilfevereine');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (55, 'Mehrgenerationenhäuser');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (56, 'Beratungsstellen (Schuldnerberatung, Drogenberatung, Bewährungshilfe, etc.)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (57, 'Förderschulen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (58, 'Flüchtlingsorganisationen');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (60, 'Koordinierungsstelle des Modellprogramms JUGEND STÄRKEN: Aktiv in der Region (alt)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (62, 'Religions- und Glaubensgemeinschaften');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (63, 'JUGEND STÄRKEN: 1000 Chancen (Wirtschaftsjunioren)');
INSERT INTO rg_koop_bewertungen_institution_art_tbl (id, value) VALUES (64, 'Sonstige');

INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (46, 'Arbeitgeber*innen / Betriebe');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (47, 'Handwerks-/ Industrie- und Handelskammer');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (48, 'Bildungsträger für Aus- und Weiterbildung');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (49, 'Träger der politischen Bildung');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (50, 'Begegnungsstätten / Kulturzentren');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (51, 'Kirchengemeinden');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (52, 'Medien (Presse, Funk und Fernsehen)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (53, 'Stiftungen');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (54, 'Selbsthilfevereine');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (55, 'Mehrgenerationenhäuser');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (56, 'Beratungsstellen (Schuldnerberatung, Drogenberatung, Bewährungshilfe, etc.)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (62, 'Religions- und Glaubensgemeinschaften');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (63, 'JUGEND STÄRKEN: 1000 Chancen (Wirtschaftsjunioren) (Altdaten)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (64, 'Sonstige');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (65, 'JUGEND STÄRKEN im Quartier (JUSTiQ) (Altdaten)');
INSERT INTO rg_koop_5_institution_art_tbl (id, value) VALUES (66, 'JUGEND STÄRKEN');

INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (35, 'Jobcenter');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (36, 'Ausländerbehörde');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (37, 'Ausgleichsamt / Vertriebenenamt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (38, 'Sozialamt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (39, 'Gesundheitsamt / Krankenhäuser / Ärzte');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (40, 'Stadtverwaltung / Gemeindeverwaltung / Bürgeramt / Meldestelle');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (41, 'Kreisverwaltung / Landratsamt / Regierungsbezirke');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (42, 'Polizei');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (44, 'Jugendstrafanstalt');
INSERT INTO rg_koop_4_institution_art_tbl (id, value) VALUES (45, 'Sonstige');

INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (28, 'Allgemeinbildende Schulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (29, 'Weiterführende Schulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (30, 'Berufliche Schulen / Berufsschulen');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (31, 'Schulamt / Schulverwaltung');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (32, 'Schulsozialarbeit');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (33, 'Schulpsychologischer Dienst');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (34, 'Sonstige');
INSERT INTO rg_koop_3_institution_art_tbl (id, value) VALUES (57, 'Förderschulen');

INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (14, 'Jugendmigrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (15, 'Kommunale Migrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (16, 'Migrationsberatung (MBE)');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (17, 'anderweitig geförderte Erwachsenenmigrationsdienste');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (18, 'Übergangswohnheime / Gemeinschaftsunterkünfte / Aufnahmeeinrichtungen ');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (19, 'Interkulturelle Zentren / Vereine');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (20, 'Integrationskursträger');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (21, 'Integrations-, Aussiedler*innen-, Ausländer*innenbeautragte*r');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (22, 'Kommunale Referate für Integrationsfragen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (23, 'Kompetenzzentrum für Integration (NRW)');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (24, 'Fördereinrichtungen für schulpflichtige Migrant*en*innen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (25, 'Vereine von Migrant*en*innen');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (26, 'Länderspezifische Integrationsangebote');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (27, 'Sonstige');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (43, 'Regionalkoordinator*en*innen des BAMF');
INSERT INTO rg_koop_2_institution_art_tbl (id, value) VALUES (58, 'Flüchtlingsorganisationen');

INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (0, 'Jugendamt ');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (1, 'Einrichtungen der schulbezogenen Jugendsozialarbeit');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (2, 'Ausbildungszentren / Jugendwerkstätten');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (3, 'Einrichtungen für berufsvorbereitende Maßnahmen');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (4, 'Einrichtungen für berufsbegleitende Maßnahmen');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (5, 'Beratungsstellen der öffentlichen  Jugendhilfe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (6, 'Einrichtungen der Heimerziehung');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (7, 'Jugendgerichtshilfe');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (8, 'Jugendzentren / offene Jugendarbeit');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (9, 'STÄRKEN vor Ort (alt)');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (10, 'Kompetenzagenturen (alt)');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (11, 'Koordinierungsstelle Schulverweigerung – Die 2. Chance (alt)');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (13, 'Sonstige');
INSERT INTO rg_koop_1_institution_art_tbl (id, value) VALUES (60, 'Koordinierungsstelle des Modellprogramms JUGEND STÄRKEN: Aktiv in der Region (alt)');

INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (0, 'im Stadtteil');
INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (1, 'auf kommunaler Ebene');
INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (2, 'auf Landesebene');
INSERT INTO beteiligung_integrationskonzepte_tbl (id, value) VALUES (3, 'keine Beteiligung');

INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (0, 'keine Mitarbeit durch JMD');
INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (1, 'Punktuelle Mitarbeit im Netzwerk');
INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (2, 'Regelmäßige Mitarbeit im Netzwerk');
INSERT INTO mitarbeit_netzwerk_tbl (id, value) VALUES (3, 'Federführend im Netzwerk');

INSERT INTO zielgruppen_netzwerk_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO zielgruppen_netzwerk_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO zielgruppen_netzwerk_tbl (id, value) VALUES (0, 'existiert nicht');
INSERT INTO zielgruppen_netzwerk_tbl (id, value) VALUES (1, 'existiert, aber ohne regionale Koordinierungsstelle');
INSERT INTO zielgruppen_netzwerk_tbl (id, value) VALUES (2, 'existiert, wird durch Koordinierungs- oder Regiestelle unterstützt');

INSERT INTO bildungsberatung_garantiefonds_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO bildungsberatung_garantiefonds_tbl (id, value) VALUES (0, 'Ja');
INSERT INTO bildungsberatung_garantiefonds_tbl (id, value) VALUES (1, 'Nein');

INSERT INTO traeger_integrationskurs_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO traeger_integrationskurs_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO traeger_integrationskurs_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO traeger_integrationskurs_tbl (id, value) VALUES (1, 'Ja');

INSERT INTO jmdstruktur_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO jmdstruktur_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO jmdstruktur_tbl (id, value) VALUES (0, 'Evangelische Trägergruppe');
INSERT INTO jmdstruktur_tbl (id, value) VALUES (1, 'Freie Trägergruppe');
INSERT INTO jmdstruktur_tbl (id, value) VALUES (2, 'Katholische Trägergruppe');
INSERT INTO jmdstruktur_tbl (id, value) VALUES (3, 'Arbeiterwohlfahrt');

INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (-2, 'Sonstiges');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (0, 'mehrere Landkreise oder kreisfreie Städte');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (1, 'ein Landkreis');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (2, 'mehrere Gemeinden oder Städte eines Landkreises');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (3, 'eine Gemeinde oder Stadt');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (4, 'Ein oder mehrere Stadtteile einer Stadt bzw. Stadtstaates');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (6, 'ein Landkreis und eine kreisfreie Stadt');
INSERT INTO raeumliche_zustaendigkeit_tbl (id, value) VALUES (7, 'Ein Bundesland bzw. Stadtstaat (Alteintrag ab 2019)');

INSERT INTO entstand_aus_kopie_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO entstand_aus_kopie_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO entstand_aus_kopie_tbl (id, value) VALUES (1, 'Ja');

INSERT INTO phase_tbl (id, value) VALUES (-1, 'Unbekannt');
INSERT INTO phase_tbl (id, value) VALUES (0, 'Erfassung läuft');
INSERT INTO phase_tbl (id, value) VALUES (1, 'Erfassung beendet');


-- -- --
-- -- -- END Autogenerated CREATE part of sql statements
-- -- --
-- -- --


CREATE TABLE status_tbl (
	id INTEGER PRIMARY KEY NOT NULL,
    value VARCHAR(256) NOT NULL
);

CREATE TABLE ka_status_tbl (
	id        INTEGER PRIMARY KEY NOT NULL,
	master_id INTEGER REFERENCES master_tbl(id) ON DELETE CASCADE,
	status    INTEGER DEFAULT 1 NOT NULL REFERENCES status_tbl(id),
	zugriff   timestamp,
    erstellt  timestamp,
	anonymisiert timestamp
);

INSERT INTO status_tbl (id, value) VALUES (1, 'offen');
INSERT INTO status_tbl (id, value) VALUES (2, 'geschlossen');
INSERT INTO status_tbl (id, value) VALUES (3, 'schwebend gelöscht');
INSERT INTO status_tbl (id, value) VALUES (4, 'schwebend anonymisiert');
INSERT INTO status_tbl (id, value) VALUES (5, 'anonymisiert');


CREATE TABLE tags (
    id          INTEGER PRIMARY KEY NOT NULL,
    label       VARCHAR(256) NOT NULL,
    description TEXT,
    systemtag   BOOLEAN DEFAULT TRUE
);

-- -- --
-- -- -- START Autogenerated CREATE part of sql statements for tag
-- -- --
-- -- --

INSERT INTO tags (id, label, description) VALUES (0, 'Alle', 'Jede Statistik hat einen Tag');
INSERT INTO tags (id, label, description) VALUES (1, 'Grundsätzlich Auswertbar', 'Die JMD-Statistik ist konsistent und weist die benötigten Validitäten auf, die für eine grundsätzliche Auswertung erfüllt sein müssen. Die Statistik steht in Auswertungen zur Verfügung');
INSERT INTO tags (id, label, description) VALUES (2, 'Auswertbar', 'Die JMD-Statistik ist grundsätzlich auswertbar, darüber hinaus wurde sie als vollständig markiert (die Checkbox auf Seite 5 ist gesetzt).');
INSERT INTO tags (id, label, description) VALUES (10, 'Datumsangaben konsistent', 'Alle Datumsangaben in der Statistik befinden sich in chronologisch korrekter Reihenfolge und liegen nicht in der Zukunft');
INSERT INTO tags (id, label, description) VALUES (11, 'Status der Erfassung gesetzt', 'Der Status der Erfassung der Statistik muss "Erfassung Beendet" sein');
INSERT INTO tags (id, label, description) VALUES (12, 'Angaben vollständig', 'Die Angaben sind vollständig und sollen ausgewertet werden (die Checkbox auf Seite 5 ist angekreuzt).');
INSERT INTO tags (id, label, description) VALUES (100, 'Doppelte JMD-Statistik', 'Es darf nur eine JMD-Statistik pro Jahr angelegt werden. Doppelte Statistiken
werden nicht bei der Auswertung berücksichtigt.');
INSERT INTO tags (id, label, description) VALUES (101, 'Start- und Enddaten gesetzt', 'Die Angaben zum Start und Ende des Zeitraums müssen angegeben werden.');
INSERT INTO tags (id, label, description) VALUES (1000, 'Das Datum "Datum Beginn Zeitraum" darf nicht "unbekannt" sein.', 'Das Datum "Datum Beginn Zeitraum" darf nicht "unbekannt" sein.');
INSERT INTO tags (id, label, description) VALUES (1001, 'Das Datum "Datum Ende Zeitraum" darf nicht "unbekannt" sein.', 'Das Datum "Datum Ende Zeitraum" darf nicht "unbekannt" sein.');
INSERT INTO tags (id, label, description) VALUES (1002, '"datum_begin_zeitraum" muss vor "datum_ende_zeitraum" liegen.', '"Datum Beginn Zeitraum" darf zeitlich nicht nach "Datum Ende Zeitraum" liegen.');
INSERT INTO tags (id, label, description) VALUES (1003, 'Summe der prozentualen Verteilung der Arbeitsanteile auf Aufgabenbereiche muss 100 Prozent sein', 'Summe der prozentualen Verteilung der Arbeitsanteile auf Aufgabenbereiche muss 100 Prozent sein');

-- -- --
-- -- -- END Autogenerated CREATE part of sql statements for tag
-- -- --
-- -- --

CREATE TABLE nm_tags_cases ( 
    id        INTEGER PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL REFERENCES master_tbl(id) ON DELETE CASCADE,
    tag_id    INTEGER NOT NULL REFERENCES tags(id),
    created   TIMESTAMP,
    UNIQUE (master_id, tag_id)
);

CREATE TABLE ka_logbuch_typ_tbl (
    id         SERIAL NOT NULL,
    beschreibung VARCHAR(256),
    CONSTRAINT ka_logbuch_typ_tbl_pkey PRIMARY KEY (id)
);

INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (0, 'nicht aufsuchend');
INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (1, 'aufsuchend');
INSERT INTO ka_logbuch_typ_tbl (id, beschreibung) VALUES (-1, 'Keine Angabe');

CREATE TABLE ka_logbuch_art_tbl (
    id         INTEGER NOT NULL,
    beschreibung VARCHAR(256),
    CONSTRAINT ka_logbuch_art_tbl_pkey PRIMARY KEY (id)
);

-- unmittelbare Arbeit mit dem Jugendlichen
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 0, 'Automatischer Eintrag');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 1, 'Gespräch mit dem/der Jugendlichen'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 2, 'Kompetenzfeststellung'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 3, 'Korrespondenz mit dem/der Jugendlichen (Telefonate/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 4, 'Begleitung des/der Jugendlichen zu externen Stellen'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 5, 'Sonstige Begleitung des Jugendlichen'); 
-- Arbeit mit Eltern/Personensorgeberechtigte
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 6, 'Gespräch mit Eltern/Personensorgeberechtigten'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 7, 'Korrespondenz mit Eltern/Personensorgeberechtigten (Telefonat/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 8, 'Sonstige Maßnahmen der Elternarbeit'); 
-- Arbeit mit Dritten 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 12, 'Gespräch mit beteiligten Dritten/Kooperationspartnern'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 13, 'Korrespondenz mit beteiligten Dritten/Kooperationspartnern (Telefonat/Schriftverkehr)'); 
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 14, 'Fallkonferenz');
-- Sonstiges
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 15, 'Fahrtwege');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 16, 'Dokumentationi i-mpuls JMD');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 17, 'Teambesprechung');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES ( 18, 'Gespräch mit Mitarbeiter/-innen der Jugendhilfe');
INSERT INTO ka_logbuch_art_tbl (id, beschreibung) VALUES (-2, 'Sonstiges');

CREATE TABLE ka_logbuch_tbl (
    id         INTEGER NOT NULL,
    master_id  int4 REFERENCES master_tbl(id)         ON DELETE CASCADE,
    datum      TIMESTAMP,
    bearbeiter VARCHAR(256),
    typ        int4 REFERENCES ka_logbuch_typ_tbl(id) ON DELETE SET DEFAULT,
    kurz_notiz VARCHAR(256),
    notiz      text,
    dauer      interval,
    CONSTRAINT ka_logbuch_tbl_pkey PRIMARY KEY (id)
);

CREATE TABLE nm_logbuch_art_tbl (
    parent_id int4 NOT NULL REFERENCES ka_logbuch_tbl(id) ON DELETE CASCADE,
    choice_id int4 NOT NULL REFERENCES ka_logbuch_art_tbl(id),

    PRIMARY KEY (parent_id, choice_id)
);

-- -- --
-- -- -- START Autogenerated INSERT part of sql statements
-- -- -- 
-- -- --


-- -- --
-- -- --
-- -- -- END Autogenerated INSERT part of sql statements
-- -- -- 

COMMIT;
