-- mpuls/issue6939: Personen und Stellenanteile
--
-- There's going to be exactly one tuple in this table, so we don't need
-- an ID column or other primary key.
CREATE TABLE coaches_stellen_tbl (
    personen INTEGER,
    stellenanteile NUMERIC(5, 3)
);

INSERT INTO coaches_stellen_tbl DEFAULT VALUES;

-- The columns id and fkz are dummies needed for data export to the
-- evaluation server. The id column will not actually be used and fkz
-- will be filled in during export.
CREATE OR REPLACE VIEW coaches_stellen_tbl_anonym_view
AS SELECT 0 AS id, ('' ::  VARCHAR(60)) as fkz, personen, stellenanteile
     FROM coaches_stellen_tbl;


GRANT SELECT ON coaches_stellen_tbl TO GROUP :cm_group;
GRANT SELECT ON coaches_stellen_tbl TO GROUP :admin_group;
GRANT UPDATE ON coaches_stellen_tbl TO GROUP :cm_group;
