--
-- Schema generated by Libformed
-- Tue, 2022-07-26 17:14:10 +0000
-- # Revision: $Revision: f1588df74250 $
--
-- # tables: 16
--

--
-- GRANTS ON TABLES
--
--
--
-- views for master table and repeat groups
--
CREATE OR REPLACE VIEW master_tbl_view
AS SELECT 
     master_tbl.id AS id,
     master_tbl.uuid_id AS uuid_id,
     master_tbl.bearbeiter_id AS bearbeiter_id,
     master_tbl.fkz AS fkz,
     master_tbl.phase AS phase,
     master_tbl.name_der_schule AS name_der_schule,
     master_tbl.schulform AS schulform,
     master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
     master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
     master_tbl.weitere_angaben_kooperationsvereinbarung AS weitere_angaben_kooperationsvereinbarung,
     master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
     master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
     master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
     master_tbl.weitere_angaben_praeventionskonzept AS weitere_angaben_praeventionskonzept,
     ( COALESCE( (SELECT SUM( COALESCE( anzahl_individuelle_beratungen , 0 ) ) FROM rg_gruppenangebote_tbl rg WHERE rg.master_id = master_tbl.id ) , 0 ) ) as individuelle_beratungen_gesamt
FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD (
    UPDATE master_tbl SET
        phase = NEW.phase,
        name_der_schule = NEW.name_der_schule,
        schulform = NEW.schulform,
        schulform_nennung_sonstige = NEW.schulform_nennung_sonstige,
        schriftliche_kooperationsvereinbarung = NEW.schriftliche_kooperationsvereinbarung,
        weitere_angaben_kooperationsvereinbarung = NEW.weitere_angaben_kooperationsvereinbarung,
        datum_begin_kooperation = NEW.datum_begin_kooperation,
        datum_ende_kooperation = NEW.datum_ende_kooperation,
        praeventionskonzept_vorhanden = NEW.praeventionskonzept_vorhanden,
        weitere_angaben_praeventionskonzept = NEW.weitere_angaben_praeventionskonzept
    WHERE id = NEW.id;
);
CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    master_tbl.id AS id,
    NULL::CHAR(36) AS uuid_id,
    master_tbl.bearbeiter_id AS bearbeiter_id,
    master_tbl.fkz AS fkz,
    master_tbl.phase AS phase,
    master_tbl.name_der_schule AS name_der_schule,
    master_tbl.schulform AS schulform,
    master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
    master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
    NULL::TEXT AS weitere_angaben_kooperationsvereinbarung,
    master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
    master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
    master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
    NULL::TEXT AS weitere_angaben_praeventionskonzept,
    master_tbl.individuelle_beratungen_gesamt AS individuelle_beratungen_gesamt FROM master_tbl_view master_tbl
    INNER JOIN ka_status_tbl s ON master_tbl.id = s.master_id
    WHERE  s.status <> 3;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_view
AS SELECT 
     rg_gruppenangebote_tbl.id AS id,
     rg_gruppenangebote_tbl.master_id AS master_id,
     rg_gruppenangebote_tbl.uuid_id AS uuid_id,
     rg_gruppenangebote_tbl.name_gruppenangebot AS name_gruppenangebot,
     rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
     rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_divers AS anzahl_teilnehmer_divers,
     ARRAY(SELECT choice_id FROM nm_klassenstufen_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS klassenstufen,
     ARRAY(SELECT choice_id FROM nm_inhalte_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS inhalte,
     rg_gruppenangebote_tbl.inhalt_weitere_angaben AS inhalt_weitere_angaben,
     ARRAY(SELECT choice_id FROM nm_format_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS format,
     rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
     ARRAY(SELECT choice_id FROM nm_methode_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS methode,
     rg_gruppenangebote_tbl.methode_weitere_angaben AS methode_weitere_angaben,
     rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
     rg_gruppenangebote_tbl.wie_gruppenangebot AS wie_gruppenangebot,
     rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
     rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
     rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
     rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
     rg_gruppenangebote_tbl.weitere_angaben_gruppenangebot AS weitere_angaben_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen
FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_gruppenangebote_tbl_view
DO INSTEAD (
    UPDATE rg_gruppenangebote_tbl SET
        name_gruppenangebot = NEW.name_gruppenangebot,
        datum_start_gruppenangebot = NEW.datum_start_gruppenangebot,
        datum_ende_gruppenangebot = NEW.datum_ende_gruppenangebot,
        anzahl_teilnehmer_maennlich = NEW.anzahl_teilnehmer_maennlich,
        anzahl_teilnehmer_weiblich = NEW.anzahl_teilnehmer_weiblich,
        anzahl_teilnehmer_divers = NEW.anzahl_teilnehmer_divers,
        inhalt_weitere_angaben = NEW.inhalt_weitere_angaben,
        format_nennung_sonstiges = NEW.format_nennung_sonstiges,
        methode_weitere_angaben = NEW.methode_weitere_angaben,
        ort_gruppenangebot = NEW.ort_gruppenangebot,
        wie_gruppenangebot = NEW.wie_gruppenangebot,
        anbieter_politische_bildung = NEW.anbieter_politische_bildung,
        anbieter_extremismuspraevention = NEW.anbieter_extremismuspraevention,
        anbieter_sonstiges = NEW.anbieter_sonstiges,
        anbieter_nennung_sonstiges = NEW.anbieter_nennung_sonstiges,
        weitere_angaben_gruppenangebot = NEW.weitere_angaben_gruppenangebot,
        anzahl_individuelle_beratungen = NEW.anzahl_individuelle_beratungen
    WHERE id = NEW.id;
    DELETE FROM nm_klassenstufen_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.klassenstufen);
    INSERT INTO nm_klassenstufen_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM klassenstufen_tbl a
          WHERE a.id = ANY (new.klassenstufen)
            AND NOT a.id = ANY (old.klassenstufen);

    DELETE FROM nm_inhalte_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.inhalte);
    INSERT INTO nm_inhalte_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM inhalte_tbl a
          WHERE a.id = ANY (new.inhalte)
            AND NOT a.id = ANY (old.inhalte);

    DELETE FROM nm_format_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.format);
    INSERT INTO nm_format_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM format_tbl a
          WHERE a.id = ANY (new.format)
            AND NOT a.id = ANY (old.format);

    DELETE FROM nm_methode_tbl
     WHERE rg_gruppenangebote_id = new.id
       AND NOT choice_id = ANY (new.methode);
    INSERT INTO nm_methode_tbl (rg_gruppenangebote_id, choice_id)
         SELECT new.id as rg_gruppenangebote_id, a.id as choice_id
           FROM methode_tbl a
          WHERE a.id = ANY (new.methode)
            AND NOT a.id = ANY (old.methode);
);
CREATE OR REPLACE RULE rg_gruppenangebote_tbl_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_anonym_view
AS SELECT
    rg_gruppenangebote_tbl.id AS id,
    rg_gruppenangebote_tbl.master_id AS master_id,
    NULL::CHAR(36) AS uuid_id,
    NULL::VARCHAR(60) AS name_gruppenangebot,
    rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
    rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_divers AS anzahl_teilnehmer_divers,
    ARRAY(SELECT choice_id FROM nm_klassenstufen_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS klassenstufen,
    ARRAY(SELECT choice_id FROM nm_inhalte_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS inhalte,
    rg_gruppenangebote_tbl.inhalt_weitere_angaben AS inhalt_weitere_angaben,
    ARRAY(SELECT choice_id FROM nm_format_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS format,
    rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
    ARRAY(SELECT choice_id FROM nm_methode_tbl nm WHERE nm.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id) AS methode,
    rg_gruppenangebote_tbl.methode_weitere_angaben AS methode_weitere_angaben,
    rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
    rg_gruppenangebote_tbl.wie_gruppenangebot AS wie_gruppenangebot,
    rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
    rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
    rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
    rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
    NULL::TEXT AS weitere_angaben_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_klassenstufen_tbl_view
AS SELECT 
     nm_klassenstufen_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_klassenstufen_tbl.choice_id AS choice_id
FROM nm_klassenstufen_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_klassenstufen_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_klassenstufen_tbl_update_rule AS ON UPDATE TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_klassenstufen_tbl_delete_rule AS ON DELETE TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_insert_rule AS ON INSERT TO nm_klassenstufen_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_klassenstufen_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_klassenstufen_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_klassenstufen_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_klassenstufen_tbl_anonym_view
AS SELECT
    nm_klassenstufen_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_klassenstufen_tbl.choice_id AS choice_id FROM nm_klassenstufen_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_klassenstufen_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_anonym_delete_rule AS ON DELETE TO nm_klassenstufen_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_klassenstufen_tbl_anonym_insert_rule AS ON INSERT TO nm_klassenstufen_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_klassenstufen_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_klassenstufen_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_inhalte_tbl_view
AS SELECT 
     nm_inhalte_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_inhalte_tbl.choice_id AS choice_id
FROM nm_inhalte_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_inhalte_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_inhalte_tbl_update_rule AS ON UPDATE TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_inhalte_tbl_delete_rule AS ON DELETE TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_inhalte_tbl_insert_rule AS ON INSERT TO nm_inhalte_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_inhalte_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_inhalte_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_inhalte_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_inhalte_tbl_anonym_view
AS SELECT
    nm_inhalte_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_inhalte_tbl.choice_id AS choice_id FROM nm_inhalte_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_inhalte_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_inhalte_tbl_anonym_delete_rule AS ON DELETE TO nm_inhalte_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_inhalte_tbl_anonym_insert_rule AS ON INSERT TO nm_inhalte_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_inhalte_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_inhalte_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_format_tbl_view
AS SELECT 
     nm_format_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_format_tbl.choice_id AS choice_id
FROM nm_format_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_format_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_format_tbl_update_rule AS ON UPDATE TO nm_format_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_format_tbl_delete_rule AS ON DELETE TO nm_format_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_format_tbl_insert_rule AS ON INSERT TO nm_format_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_format_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_format_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_format_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_format_tbl_anonym_view
AS SELECT
    nm_format_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_format_tbl.choice_id AS choice_id FROM nm_format_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_format_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_format_tbl_anonym_delete_rule AS ON DELETE TO nm_format_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_format_tbl_anonym_insert_rule AS ON INSERT TO nm_format_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_format_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_format_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_methode_tbl_view
AS SELECT 
     nm_methode_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
     nm_methode_tbl.choice_id AS choice_id
FROM nm_methode_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_methode_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE nm_methode_tbl_update_rule AS ON UPDATE TO nm_methode_tbl_view
    DO INSTEAD NOTHING;
CREATE OR REPLACE RULE nm_methode_tbl_delete_rule AS ON DELETE TO nm_methode_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_methode_tbl_insert_rule AS ON INSERT TO nm_methode_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_methode_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON nm_methode_tbl_view TO GROUP :cm_group;
GRANT SELECT ON nm_methode_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW nm_methode_tbl_anonym_view
AS SELECT
    nm_methode_tbl.rg_gruppenangebote_id AS rg_gruppenangebote_id,
    nm_methode_tbl.choice_id AS choice_id FROM nm_methode_tbl
    INNER JOIN rg_gruppenangebote_tbl
    ON         nm_methode_tbl.rg_gruppenangebote_id = rg_gruppenangebote_tbl.id
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE nm_methode_tbl_anonym_delete_rule AS ON DELETE TO nm_methode_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE nm_methode_tbl_anonym_insert_rule AS ON INSERT TO nm_methode_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON nm_methode_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON nm_methode_tbl_anonym_view TO GROUP :admin_group;

--
-- Function to anonymize a case and all of its repeat groups
--
CREATE OR REPLACE FUNCTION anonymize_case(mid int)
RETURNS void AS
$$
BEGIN
    PERFORM anonymize_uuid(mid);
    -- anonymize master table
    UPDATE master_tbl_view SET
        uuid_id = NULL,
        weitere_angaben_kooperationsvereinbarung = NULL,
        weitere_angaben_praeventionskonzept = NULL
    WHERE id = mid;

    -- anonymize repeat groups
    UPDATE rg_gruppenangebote_tbl_view SET
        uuid_id = NULL,
        name_gruppenangebot = NULL,
        weitere_angaben_gruppenangebot = NULL
    WHERE master_id = mid;

END;
$$ LANGUAGE plpgsql VOLATILE SECURITY DEFINER;

REVOKE ALL ON FUNCTION anonymize_case(int) FROM public;
GRANT EXECUTE ON FUNCTION anonymize_case(int) TO GROUP :admin_group;

-- Create a default (not very performant) evaluation view.
-- This is based on master_tbl_view so that the restrictions
-- based on the user-id implemented by master_tbl_view are
-- also applied to master_tbl_eval_total_view. It suffices
-- to restrict the view to entries that are not marked for
-- deletion.
CREATE OR REPLACE VIEW master_tbl_eval_total_view AS
    SELECT m.*
    FROM master_tbl_view m JOIN ka_status_tbl s
    ON m.id = s.master_id
    WHERE s.status <> 3;

GRANT SELECT ON master_tbl_eval_total_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_eval_total_view TO GROUP :admin_group;

