-- In older struktur-part databases, the ka_dokumente_tbl is missing the
-- column datum. Newer databases have it. This seems to be due to the
-- column having been added to mpuls after JMD was started and the
-- corresponding update was only applied to the CM-part. It was probably
-- omitted for the struktur part because the ka_dokumente_tbl is not
-- used there.

-- In order to make sure all databases have the same schema for the
-- parts shared by all mpuls applications, we add the datum column now
-- in those database where it's not present yet.

DO $$
DECLARE
    status text;
BEGIN
    ALTER TABLE ka_dokumente_tbl ADD COLUMN datum DATE;
EXCEPTION WHEN duplicate_column THEN
    -- the column already exists, so do nothing.
END
$$;
