BEGIN;
-- issue2167: Erhöhung der Anzahl der vereinbarten Ziele
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/08_unterziele.sql', current_timestamp);


-- ----------------------------------------------------------
-- Erhöt die Anzahl der vereinbarten Ziele von 3 auf 5
-- ----------------------------------------------------------
DROP VIEW rg_ziele_tbl_view CASCADE;

-- loescht ebenfalls Regel _RETURN fuer Sicht rg_ziele_tbl_anonym_view
-- loescht ebenfalls Sicht rg_ziele_tbl_anonym_view
-- loescht ebenfalls Regel rg_ziele_tbl_anonym_insert_rule fuer Sicht rg_ziele_tbl_anonym_view
-- loescht ebenfalls Regel rg_ziele_tbl_anonym_delete_rule fuer Sicht rg_ziele_tbl_anonym_view

ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel4 VARCHAR(60);
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel4_erreicht INTEGER DEFAULT -1;
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel4_angebot INTEGER DEFAULT -1;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel4_art TEXT;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel4_datum_start DATE;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel4_datum_ende DATE;
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_externe_einrichtung_4_name VARCHAR(60);
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_externe_einrichtung_4_datum DATE;

ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel5 VARCHAR(60);
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel5_erreicht INTEGER DEFAULT -1;
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_uziel5_angebot INTEGER DEFAULT -1;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel5_art TEXT;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel5_datum_start DATE;
ALTER TABLE rg_ziele_tbl ADD COLUMN ua_uziel5_datum_ende DATE;
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_externe_einrichtung_5_name VARCHAR(60);
ALTER TABLE rg_ziele_tbl ADD COLUMN fp_externe_einrichtung_5_datum DATE;



CREATE OR REPLACE VIEW rg_ziele_tbl_view
AS SELECT 
     rg_ziele_tbl.id AS id,
     rg_ziele_tbl.master_id AS master_id,
     rg_ziele_tbl.uuid_id AS uuid_id,
     rg_ziele_tbl.fp_ziel AS fp_ziel,
     rg_ziele_tbl.fp_ziel_erreicht AS fp_ziel_erreicht,
     rg_ziele_tbl.fp_ziel_sonstiges AS fp_ziel_sonstiges,
     rg_ziele_tbl.fp_ziel_beschreibung AS fp_ziel_beschreibung,
     rg_ziele_tbl.fp_leistung_teilnehmer AS fp_leistung_teilnehmer,
     rg_ziele_tbl.fp_leistung_jmd AS fp_leistung_jmd,
     rg_ziele_tbl.fp_datum_vereinbarung AS fp_datum_vereinbarung,
     rg_ziele_tbl.fp_datum_umsetzung AS fp_datum_umsetzung,
     rg_ziele_tbl.fp_uziel1 AS fp_uziel1,
     rg_ziele_tbl.fp_uziel1_erreicht AS fp_uziel1_erreicht,
     rg_ziele_tbl.fp_uziel1_angebot AS fp_uziel1_angebot,
     rg_ziele_tbl.ua_uziel1_art AS ua_uziel1_art,
     rg_ziele_tbl.ua_uziel1_datum_start AS ua_uziel1_datum_start,
     rg_ziele_tbl.ua_uziel1_datum_ende AS ua_uziel1_datum_ende,
     rg_ziele_tbl.fp_externe_einrichtung_1_name AS fp_externe_einrichtung_1_name,
     rg_ziele_tbl.fp_externe_einrichtung_1_datum AS fp_externe_einrichtung_1_datum,
     rg_ziele_tbl.fp_uziel2 AS fp_uziel2,
     rg_ziele_tbl.fp_uziel2_erreicht AS fp_uziel2_erreicht,
     rg_ziele_tbl.fp_uziel2_angebot AS fp_uziel2_angebot,
     rg_ziele_tbl.ua_uziel2_art AS ua_uziel2_art,
     rg_ziele_tbl.ua_uziel2_datum_start AS ua_uziel2_datum_start,
     rg_ziele_tbl.ua_uziel2_datum_ende AS ua_uziel2_datum_ende,
     rg_ziele_tbl.fp_externe_einrichtung_2_name AS fp_externe_einrichtung_2_name,
     rg_ziele_tbl.fp_externe_einrichtung_2_datum AS fp_externe_einrichtung_2_datum,
     rg_ziele_tbl.fp_uziel3 AS fp_uziel3,
     rg_ziele_tbl.fp_uziel3_erreicht AS fp_uziel3_erreicht,
     rg_ziele_tbl.fp_uziel3_angebot AS fp_uziel3_angebot,
     rg_ziele_tbl.ua_uziel3_art AS ua_uziel3_art,
     rg_ziele_tbl.ua_uziel3_datum_start AS ua_uziel3_datum_start,
     rg_ziele_tbl.ua_uziel3_datum_ende AS ua_uziel3_datum_ende,
     rg_ziele_tbl.fp_externe_einrichtung_3_name AS fp_externe_einrichtung_3_name,
     rg_ziele_tbl.fp_externe_einrichtung_3_datum AS fp_externe_einrichtung_3_datum,
     rg_ziele_tbl.fp_uziel4 AS fp_uziel4,
     rg_ziele_tbl.fp_uziel4_erreicht AS fp_uziel4_erreicht,
     rg_ziele_tbl.fp_uziel4_angebot AS fp_uziel4_angebot,
     rg_ziele_tbl.ua_uziel4_art AS ua_uziel4_art,
     rg_ziele_tbl.ua_uziel4_datum_start AS ua_uziel4_datum_start,
     rg_ziele_tbl.ua_uziel4_datum_ende AS ua_uziel4_datum_ende,
     rg_ziele_tbl.fp_externe_einrichtung_4_name AS fp_externe_einrichtung_4_name,
     rg_ziele_tbl.fp_externe_einrichtung_4_datum AS fp_externe_einrichtung_4_datum,
     rg_ziele_tbl.fp_uziel5 AS fp_uziel5,
     rg_ziele_tbl.fp_uziel5_erreicht AS fp_uziel5_erreicht,
     rg_ziele_tbl.fp_uziel5_angebot AS fp_uziel5_angebot,
     rg_ziele_tbl.ua_uziel5_art AS ua_uziel5_art,
     rg_ziele_tbl.ua_uziel5_datum_start AS ua_uziel5_datum_start,
     rg_ziele_tbl.ua_uziel5_datum_ende AS ua_uziel5_datum_ende,
     rg_ziele_tbl.fp_externe_einrichtung_5_name AS fp_externe_einrichtung_5_name,
     rg_ziele_tbl.fp_externe_einrichtung_5_datum AS fp_externe_einrichtung_5_datum
FROM rg_ziele_tbl
    INNER JOIN master_tbl
    ON         rg_ziele_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_ziele_tbl_update_rule AS ON UPDATE TO rg_ziele_tbl_view
DO INSTEAD UPDATE rg_ziele_tbl SET
    fp_ziel = NEW.fp_ziel,
    fp_ziel_erreicht = NEW.fp_ziel_erreicht,
    fp_ziel_sonstiges = NEW.fp_ziel_sonstiges,
    fp_ziel_beschreibung = NEW.fp_ziel_beschreibung,
    fp_leistung_teilnehmer = NEW.fp_leistung_teilnehmer,
    fp_leistung_jmd = NEW.fp_leistung_jmd,
    fp_datum_vereinbarung = NEW.fp_datum_vereinbarung,
    fp_datum_umsetzung = NEW.fp_datum_umsetzung,
    fp_uziel1 = NEW.fp_uziel1,
    fp_uziel1_erreicht = NEW.fp_uziel1_erreicht,
    fp_uziel1_angebot = NEW.fp_uziel1_angebot,
    ua_uziel1_art = NEW.ua_uziel1_art,
    ua_uziel1_datum_start = NEW.ua_uziel1_datum_start,
    ua_uziel1_datum_ende = NEW.ua_uziel1_datum_ende,
    fp_externe_einrichtung_1_name = NEW.fp_externe_einrichtung_1_name,
    fp_externe_einrichtung_1_datum = NEW.fp_externe_einrichtung_1_datum,
    fp_uziel2 = NEW.fp_uziel2,
    fp_uziel2_erreicht = NEW.fp_uziel2_erreicht,
    fp_uziel2_angebot = NEW.fp_uziel2_angebot,
    ua_uziel2_art = NEW.ua_uziel2_art,
    ua_uziel2_datum_start = NEW.ua_uziel2_datum_start,
    ua_uziel2_datum_ende = NEW.ua_uziel2_datum_ende,
    fp_externe_einrichtung_2_name = NEW.fp_externe_einrichtung_2_name,
    fp_externe_einrichtung_2_datum = NEW.fp_externe_einrichtung_2_datum,
    fp_uziel3 = NEW.fp_uziel3,
    fp_uziel3_erreicht = NEW.fp_uziel3_erreicht,
    fp_uziel3_angebot = NEW.fp_uziel3_angebot,
    ua_uziel3_art = NEW.ua_uziel3_art,
    ua_uziel3_datum_start = NEW.ua_uziel3_datum_start,
    ua_uziel3_datum_ende = NEW.ua_uziel3_datum_ende,
    fp_externe_einrichtung_3_name = NEW.fp_externe_einrichtung_3_name,
    fp_externe_einrichtung_3_datum = NEW.fp_externe_einrichtung_3_datum,
    fp_uziel4 = NEW.fp_uziel4,
    fp_uziel4_erreicht = NEW.fp_uziel4_erreicht,
    fp_uziel4_angebot = NEW.fp_uziel4_angebot,
    ua_uziel4_art = NEW.ua_uziel4_art,
    ua_uziel4_datum_start = NEW.ua_uziel4_datum_start,
    ua_uziel4_datum_ende = NEW.ua_uziel4_datum_ende,
    fp_externe_einrichtung_4_name = NEW.fp_externe_einrichtung_4_name,
    fp_externe_einrichtung_4_datum = NEW.fp_externe_einrichtung_4_datum,
    fp_uziel5 = NEW.fp_uziel5,
    fp_uziel5_erreicht = NEW.fp_uziel5_erreicht,
    fp_uziel5_angebot = NEW.fp_uziel5_angebot,
    ua_uziel5_art = NEW.ua_uziel5_art,
    ua_uziel5_datum_start = NEW.ua_uziel5_datum_start,
    ua_uziel5_datum_ende = NEW.ua_uziel5_datum_ende,
    fp_externe_einrichtung_5_name = NEW.fp_externe_einrichtung_5_name,
    fp_externe_einrichtung_5_datum = NEW.fp_externe_einrichtung_5_datum
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_ziele_tbl_delete_rule AS ON DELETE TO rg_ziele_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_ziele_tbl_insert_rule AS ON INSERT TO rg_ziele_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_ziele_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_ziele_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_ziele_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_ziele_tbl_anonym_view
AS SELECT
    id,
    master_id,
    uuid_id,
    fp_ziel,
    fp_ziel_erreicht,
    NULL::VARCHAR(60) AS fp_ziel_sonstiges,
    NULL::TEXT AS fp_ziel_beschreibung,
    NULL::TEXT AS fp_leistung_teilnehmer,
    NULL::TEXT AS fp_leistung_jmd,
    fp_datum_vereinbarung,
    fp_datum_umsetzung,
    NULL::VARCHAR(60) AS fp_uziel1,
    fp_uziel1_erreicht,
    fp_uziel1_angebot,
    NULL::TEXT AS ua_uziel1_art,
    ua_uziel1_datum_start,
    ua_uziel1_datum_ende,
    NULL::VARCHAR(60) AS fp_externe_einrichtung_1_name,
    fp_externe_einrichtung_1_datum,
    NULL::VARCHAR(60) AS fp_uziel2,
    fp_uziel2_erreicht,
    fp_uziel2_angebot,
    NULL::TEXT AS ua_uziel2_art,
    ua_uziel2_datum_start,
    ua_uziel2_datum_ende,
    NULL::VARCHAR(60) AS fp_externe_einrichtung_2_name,
    fp_externe_einrichtung_2_datum,
    NULL::VARCHAR(60) AS fp_uziel3,
    fp_uziel3_erreicht,
    fp_uziel3_angebot,
    NULL::TEXT AS ua_uziel3_art,
    ua_uziel3_datum_start,
    ua_uziel3_datum_ende,
    NULL::VARCHAR(60) AS fp_externe_einrichtung_3_name,
    fp_externe_einrichtung_3_datum,
    NULL::VARCHAR(60) AS fp_uziel4,
    fp_uziel4_erreicht,
    fp_uziel4_angebot,
    NULL::TEXT AS ua_uziel4_art,
    ua_uziel4_datum_start,
    ua_uziel4_datum_ende,
    NULL::VARCHAR(60) AS fp_externe_einrichtung_4_name,
    fp_externe_einrichtung_4_datum,
    NULL::VARCHAR(60) AS fp_uziel5,
    fp_uziel5_erreicht,
    fp_uziel5_angebot,
    NULL::TEXT AS ua_uziel5_art,
    ua_uziel5_datum_start,
    ua_uziel5_datum_ende,
    NULL::VARCHAR(60) AS fp_externe_einrichtung_5_name,
    fp_externe_einrichtung_5_datum FROM rg_ziele_tbl_view;

CREATE OR REPLACE RULE rg_ziele_tbl_anonym_delete_rule AS ON DELETE TO rg_ziele_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_ziele_tbl_anonym_insert_rule AS ON INSERT TO rg_ziele_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_ziele_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_ziele_tbl_anonym_view TO GROUP :admin_group;


--
-- Finish
--
SET ROLE postgres;
COMMIT;
--ROLLBACK;
