BEGIN;

-- 2.0-pre1 -> 2.0-pre2
-- muttersprache für den Jugendlichen.
-- muttersprache für die Eltern entfernt
-- 

SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('2.0pre1/muttersprache.sql', current_timestamp);

-- Löschen der VIEWS
DROP VIEW master_tbl_view CASCADE;
DROP VIEW master_tbl_eval_incm_view CASCADE;
DROP VIEW master_tbl_eval_total_view CASCADE;

-- Löschen der FK-Constraints 

ALTER TABLE master_tbl DROP CONSTRAINT master_tbl_mutter_muttersprache_fkey;
ALTER TABLE master_tbl DROP CONSTRAINT master_tbl_sprache_zuhause_fkey;
ALTER TABLE master_tbl DROP CONSTRAINT master_tbl_vater_muttersprache_fkey;

-- Löschen der alten Felder
ALTER TABLE master_tbl DROP mutter_muttersprache;
ALTER TABLE master_tbl DROP vater_muttersprache;

-- Umbennen der Tabelle muttersprache
ALTER TABLE mutter_muttersprache_tbl RENAME TO muttersprache_tbl;

-- Einfügen des neuen Feldes muttersprache
ALTER TABLE master_tbl ADD muttersprache INTEGER DEFAULT -1;
ALTER TABLE master_tbl ADD FOREIGN KEY (muttersprache) REFERENCES muttersprache_tbl (id);

-- Neu Anlegen der VIEWS und REGELN
-- master_tbl_view
CREATE OR REPLACE VIEW master_tbl_view
AS SELECT master_tbl.* FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2 
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    phase = NEW.phase,
    jmd_name = NEW.jmd_name,
    mitarbeiter_name = NEW.mitarbeiter_name,
    mitarbeiter_vorname = NEW.mitarbeiter_vorname,
    datum_ea_start = NEW.datum_ea_start,
    zugang = NEW.zugang,
    war_bereits_kunde = NEW.war_bereits_kunde,
    einwilligung = NEW.einwilligung,
    weitergabe_an_dritte = NEW.weitergabe_an_dritte,
    kooperation_mit_dritten = NEW.kooperation_mit_dritten,
    art_begleitung = NEW.art_begleitung,
    datum_ea_ende = NEW.datum_ea_ende,
    datum_cm_start = NEW.datum_cm_start,
    datum_ber_start = NEW.datum_ber_start,
    datum_ber_ende = NEW.datum_ber_ende,
    name = NEW.name,
    vorname = NEW.vorname,
    geburtsname = NEW.geburtsname,
    name_vor_einbuergerung = NEW.name_vor_einbuergerung,
    geburtsdatum = NEW.geburtsdatum,
    geschlecht = NEW.geschlecht,
    geburtsland = NEW.geburtsland,
    geburtsort = NEW.geburtsort,
    fuehrerschein = NEW.fuehrerschein,
    familienstand = NEW.familienstand,
    alleinerziehend = NEW.alleinerziehend,
    anzahl_geschwister = NEW.anzahl_geschwister,
    staatsangehoerigkeit = NEW.staatsangehoerigkeit,
    staatsangehoerigkeit_weitere = NEW.staatsangehoerigkeit_weitere,
    einreisedatum = NEW.einreisedatum,
    aufenthaltsstatus = NEW.aufenthaltsstatus,
    muttersprache = NEW.muttersprache,
    sprache_zuhause = NEW.sprache_zuhause,
    mutter_geburtsland = NEW.mutter_geburtsland,
    vater_geburtsland = NEW.vater_geburtsland,
    wohnsituation = NEW.wohnsituation,
    bezugsperson_a = NEW.bezugsperson_a,
    bezugsperson_b = NEW.bezugsperson_b,
    bezugsperson_c = NEW.bezugsperson_c,
    bezugsperson_d = NEW.bezugsperson_d,
    bezugsperson_e = NEW.bezugsperson_e,
    bezugsperson_f = NEW.bezugsperson_f,
    bezugsperson_g = NEW.bezugsperson_g,
    bezugsperson_h = NEW.bezugsperson_h,
    bezugsperson_i = NEW.bezugsperson_i,
    bezugsperson_j = NEW.bezugsperson_j,
    bezugsperson_k = NEW.bezugsperson_k,
    bezugsperson_l = NEW.bezugsperson_l,
    bezugsperson_m = NEW.bezugsperson_m,
    bezugsperson_n = NEW.bezugsperson_n,
    bezugsperson_o = NEW.bezugsperson_o,
    bezugsperson_p = NEW.bezugsperson_p,
    bezugsperson_q = NEW.bezugsperson_q,
    bezugsperson_r = NEW.bezugsperson_r,
    zugeh_a = NEW.zugeh_a,
    zugeh_b = NEW.zugeh_b,
    zugeh_c = NEW.zugeh_c,
    zugeh_d = NEW.zugeh_d,
    zugeh_e = NEW.zugeh_e,
    soz_engagement = NEW.soz_engagement,
    einkommen_familie = NEW.einkommen_familie,
    einkommen_jugendlicher = NEW.einkommen_jugendlicher,
    geldmittel = NEW.geldmittel,
    schulden = NEW.schulden,
    schulden_beratung = NEW.schulden_beratung,
    psychische_beeintraechtigung = NEW.psychische_beeintraechtigung,
    physische_beeintraechtugung = NEW.physische_beeintraechtugung,
    sucht = NEW.sucht,
    aktuelle_situation = NEW.aktuelle_situation,
    aktuelle_schule = NEW.aktuelle_schule,
    aktuelle_schule_klassenstufe = NEW.aktuelle_schule_klassenstufe,
    aktueller_beruf = NEW.aktueller_beruf,
    aktueller_beruf_ausbildungsjahr = NEW.aktueller_beruf_ausbildungsjahr,
    aktuelle_massnahme_art = NEW.aktuelle_massnahme_art,
    aktuelle_massnahme = NEW.aktuelle_massnahme,
    aktuelle_massnahme_beginn = NEW.aktuelle_massnahme_beginn,
    aktuelle_massnahme_dauer = NEW.aktuelle_massnahme_dauer,
    aktuelle_taetigkeit = NEW.aktuelle_taetigkeit,
    aktuelle_taetigkeit_datum_seit = NEW.aktuelle_taetigkeit_datum_seit,
    aktuelle_arbeitslosigkeit_seit = NEW.aktuelle_arbeitslosigkeit_seit,
    aktuelle_elternzeit_seit = NEW.aktuelle_elternzeit_seit,
    aktueller_zivildienst_seit = NEW.aktueller_zivildienst_seit,
    hoechster_schulabschluss = NEW.hoechster_schulabschluss,
    hoechster_schulabschluss_nennung = NEW.hoechster_schulabschluss_nennung,
    hoechster_schulabschluss_ausland = NEW.hoechster_schulabschluss_ausland,
    hoechster_schulabschluss_ausland_anerkannt = NEW.hoechster_schulabschluss_ausland_anerkannt,
    hoechster_schulabschluss_ausland_land = NEW.hoechster_schulabschluss_ausland_land,
    hoechster_schulabschluss_ausland_aequi_anerkannt = NEW.hoechster_schulabschluss_ausland_aequi_anerkannt,
    hoechster_berufsabschluss = NEW.hoechster_berufsabschluss,
    hoechster_berufsabschluss_nennung = NEW.hoechster_berufsabschluss_nennung,
    hoechster_berufsabschluss_ausland = NEW.hoechster_berufsabschluss_ausland,
    hoechster_berufsabschluss_ausland_anerkannt = NEW.hoechster_berufsabschluss_ausland_anerkannt,
    hoechster_berufsabschluss_ausland_land = NEW.hoechster_berufsabschluss_ausland_land,
    hoechster_berufsabschluss_ausland_aequi_anerkannt = NEW.hoechster_berufsabschluss_ausland_aequi_anerkannt,
    integrationskurs = NEW.integrationskurs,
    datum_integrationskurs_ende = NEW.datum_integrationskurs_ende,
    kompetenzfeststellung = NEW.kompetenzfeststellung,
    kf_verfahren_nennung = NEW.kf_verfahren_nennung,
    kf_verfahren = NEW.kf_verfahren,
    kf_erg_natur_a = NEW.kf_erg_natur_a,
    kf_erg_natur_b = NEW.kf_erg_natur_b,
    kf_erg_natur_c = NEW.kf_erg_natur_c,
    kf_erg_natur_d = NEW.kf_erg_natur_d,
    kf_erg_natur_e = NEW.kf_erg_natur_e,
    kf_erg_medien_a = NEW.kf_erg_medien_a,
    kf_erg_medien_b = NEW.kf_erg_medien_b,
    kf_erg_medien_c = NEW.kf_erg_medien_c,
    kf_erg_medien_d = NEW.kf_erg_medien_d,
    kf_erg_medien_e = NEW.kf_erg_medien_e,
    kf_erg_handwerk_a = NEW.kf_erg_handwerk_a,
    kf_erg_handwerk_b = NEW.kf_erg_handwerk_b,
    kf_erg_handwerk_c = NEW.kf_erg_handwerk_c,
    kf_erg_handwerk_d = NEW.kf_erg_handwerk_d,
    kf_erg_methode_a = NEW.kf_erg_methode_a,
    kf_erg_methode_b = NEW.kf_erg_methode_b,
    kf_erg_methode_c = NEW.kf_erg_methode_c,
    kf_erg_methode_d = NEW.kf_erg_methode_d,
    kf_erg_methode_e = NEW.kf_erg_methode_e,
    kf_erg_methode_f = NEW.kf_erg_methode_f,
    kf_erg_methode_g = NEW.kf_erg_methode_g,
    kf_erg_deutsch_a = NEW.kf_erg_deutsch_a,
    kf_erg_deutsch_b = NEW.kf_erg_deutsch_b,
    kf_erg_deutsch_c = NEW.kf_erg_deutsch_c,
    kf_erg_deutsch_d = NEW.kf_erg_deutsch_d,
    kf_erg_muttersprache_a = NEW.kf_erg_muttersprache_a,
    kf_erg_muttersprache_b = NEW.kf_erg_muttersprache_b,
    kf_erg_muttersprache_c = NEW.kf_erg_muttersprache_c,
    kf_erg_muttersprache_d = NEW.kf_erg_muttersprache_d,
    kf_erg_weiteresprache_nennung = NEW.kf_erg_weiteresprache_nennung,
    kf_erg_weiteresprache_a = NEW.kf_erg_weiteresprache_a,
    kf_erg_weiteresprache_b = NEW.kf_erg_weiteresprache_b,
    kf_erg_weiteresprache_c = NEW.kf_erg_weiteresprache_c,
    kf_erg_weiteresprache_d = NEW.kf_erg_weiteresprache_d,
    kf_erg_weiteresprache_gesamt = NEW.kf_erg_weiteresprache_gesamt,
    kf_erg_sozial_a = NEW.kf_erg_sozial_a,
    kf_erg_sozial_b = NEW.kf_erg_sozial_b,
    kf_erg_sozial_c = NEW.kf_erg_sozial_c,
    kf_erg_sozial_d = NEW.kf_erg_sozial_d,
    kf_erg_sozial_e = NEW.kf_erg_sozial_e,
    kf_erg_sozial_f = NEW.kf_erg_sozial_f,
    kf_erg_sozial_g = NEW.kf_erg_sozial_g,
    kf_erg_sozial_h = NEW.kf_erg_sozial_h,
    kf_erg_sozial_i = NEW.kf_erg_sozial_i,
    kf_erg_sozial_j = NEW.kf_erg_sozial_j,
    kf_erg_selbst_a = NEW.kf_erg_selbst_a,
    kf_erg_selbst_b = NEW.kf_erg_selbst_b,
    kf_erg_selbst_c = NEW.kf_erg_selbst_c,
    kf_erg_selbst_d = NEW.kf_erg_selbst_d,
    kf_erg_selbst_e = NEW.kf_erg_selbst_e,
    kf_erg_selbst_f = NEW.kf_erg_selbst_f,
    kf_erg_selbst_g = NEW.kf_erg_selbst_g,
    kf_erg_selbst_h = NEW.kf_erg_selbst_h,
    kf_erg_selbst_i = NEW.kf_erg_selbst_i,
    kf_erg_selbst_j = NEW.kf_erg_selbst_j,
    kf_erg_selbst_k = NEW.kf_erg_selbst_k,
    kf_erg_leistung_a = NEW.kf_erg_leistung_a,
    kf_erg_leistung_b = NEW.kf_erg_leistung_b,
    kf_erg_leistung_c = NEW.kf_erg_leistung_c,
    kf_erg_leistung_d = NEW.kf_erg_leistung_d,
    kf_erg_leistung_e = NEW.kf_erg_leistung_e,
    kf_erg_leistung_f = NEW.kf_erg_leistung_f,
    kf_erg_leistung_g = NEW.kf_erg_leistung_g,
    kf_erg_leistung_h = NEW.kf_erg_leistung_h,
    kf_erg_leistung_i = NEW.kf_erg_leistung_i,
    kf_erg_leistung_j = NEW.kf_erg_leistung_j,
    kf_erg_leistung_k = NEW.kf_erg_leistung_k,
    datum_cm_ende = NEW.datum_cm_ende,
    art_cm_ende = NEW.art_cm_ende,
    abbruch_durch = NEW.abbruch_durch,
    gruende_abbruch_cm = NEW.gruende_abbruch_cm,
    veraenderung_inst_einbindung = NEW.veraenderung_inst_einbindung,
    ende_inst_einbindung = NEW.ende_inst_einbindung,
    ziel1_erreicht = NEW.ziel1_erreicht,
    ziel2_erreicht = NEW.ziel2_erreicht,
    ziel3_erreicht = NEW.ziel3_erreicht,
    datum_verbleib_feststellung = NEW.datum_verbleib_feststellung,
    verbleib_jugendliche = NEW.verbleib_jugendliche,
    verbleib_jugendliche_sonstiges = NEW.verbleib_jugendliche_sonstiges
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

-- master_tbl_anonym_view
CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    id,
    uuid_id,
    bearbeiter_id,
    phase,
    NULL::VARCHAR(60) AS jmd_name,
    NULL::VARCHAR(60) AS mitarbeiter_name,
    NULL::VARCHAR(60) AS mitarbeiter_vorname,
    datum_ea_start,
    zugang,
    war_bereits_kunde,
    einwilligung,
    weitergabe_an_dritte,
    kooperation_mit_dritten,
    art_begleitung,
    datum_ea_ende,
    datum_cm_start,
    datum_ber_start,
    datum_ber_ende,
    NULL::VARCHAR(256) AS name,
    NULL::VARCHAR(256) AS vorname,
    NULL::VARCHAR(256) AS geburtsname,
    NULL::VARCHAR(256) AS name_vor_einbuergerung,
    geburtsdatum,
    geschlecht,
    geburtsland,
    NULL::VARCHAR(60) AS geburtsort,
    NULL::VARCHAR(60) AS fuehrerschein,
    familienstand,
    alleinerziehend,
    anzahl_geschwister,
    staatsangehoerigkeit,
    staatsangehoerigkeit_weitere,
    einreisedatum,
    aufenthaltsstatus,
    muttersprache,
    sprache_zuhause,
    mutter_geburtsland,
    vater_geburtsland,
    wohnsituation,
    bezugsperson_a,
    bezugsperson_b,
    bezugsperson_c,
    bezugsperson_d,
    bezugsperson_e,
    bezugsperson_f,
    bezugsperson_g,
    bezugsperson_h,
    bezugsperson_i,
    bezugsperson_j,
    bezugsperson_k,
    bezugsperson_l,
    bezugsperson_m,
    bezugsperson_n,
    bezugsperson_o,
    bezugsperson_p,
    bezugsperson_q,
    bezugsperson_r,
    zugeh_a,
    zugeh_b,
    zugeh_c,
    zugeh_d,
    zugeh_e,
    NULL::VARCHAR(60) AS soz_engagement,
    einkommen_familie,
    einkommen_jugendlicher,
    geldmittel,
    schulden,
    schulden_beratung,
    psychische_beeintraechtigung,
    physische_beeintraechtugung,
    sucht,
    aktuelle_situation,
    aktuelle_schule,
    aktuelle_schule_klassenstufe,
    NULL::VARCHAR(60) AS aktueller_beruf,
    aktueller_beruf_ausbildungsjahr,
    aktuelle_massnahme_art,
    NULL::VARCHAR(60) AS aktuelle_massnahme,
    aktuelle_massnahme_beginn,
    aktuelle_massnahme_dauer,
    NULL::VARCHAR(60) AS aktuelle_taetigkeit,
    aktuelle_taetigkeit_datum_seit,
    aktuelle_arbeitslosigkeit_seit,
    aktuelle_elternzeit_seit,
    aktueller_zivildienst_seit,
    hoechster_schulabschluss,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_schulabschluss_ausland,
    hoechster_schulabschluss_ausland_anerkannt,
    hoechster_schulabschluss_ausland_land,
    hoechster_schulabschluss_ausland_aequi_anerkannt,
    hoechster_berufsabschluss,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_nennung,
    NULL::VARCHAR(60) AS hoechster_berufsabschluss_ausland,
    hoechster_berufsabschluss_ausland_anerkannt,
    hoechster_berufsabschluss_ausland_land,
    hoechster_berufsabschluss_ausland_aequi_anerkannt,
    integrationskurs,
    datum_integrationskurs_ende,
    kompetenzfeststellung,
    kf_verfahren_nennung,
    kf_verfahren,
    kf_erg_natur_a,
    kf_erg_natur_b,
    kf_erg_natur_c,
    kf_erg_natur_d,
    kf_erg_natur_e,
    kf_erg_medien_a,
    kf_erg_medien_b,
    kf_erg_medien_c,
    kf_erg_medien_d,
    kf_erg_medien_e,
    kf_erg_handwerk_a,
    kf_erg_handwerk_b,
    kf_erg_handwerk_c,
    kf_erg_handwerk_d,
    kf_erg_methode_a,
    kf_erg_methode_b,
    kf_erg_methode_c,
    kf_erg_methode_d,
    kf_erg_methode_e,
    kf_erg_methode_f,
    kf_erg_methode_g,
    kf_erg_deutsch_a,
    kf_erg_deutsch_b,
    kf_erg_deutsch_c,
    kf_erg_deutsch_d,
    kf_erg_muttersprache_a,
    kf_erg_muttersprache_b,
    kf_erg_muttersprache_c,
    kf_erg_muttersprache_d,
    NULL::VARCHAR(60) AS kf_erg_weiteresprache_nennung,
    kf_erg_weiteresprache_a,
    kf_erg_weiteresprache_b,
    kf_erg_weiteresprache_c,
    kf_erg_weiteresprache_d,
    kf_erg_weiteresprache_gesamt,
    kf_erg_sozial_a,
    kf_erg_sozial_b,
    kf_erg_sozial_c,
    kf_erg_sozial_d,
    kf_erg_sozial_e,
    kf_erg_sozial_f,
    kf_erg_sozial_g,
    kf_erg_sozial_h,
    kf_erg_sozial_i,
    kf_erg_sozial_j,
    kf_erg_selbst_a,
    kf_erg_selbst_b,
    kf_erg_selbst_c,
    kf_erg_selbst_d,
    kf_erg_selbst_e,
    kf_erg_selbst_f,
    kf_erg_selbst_g,
    kf_erg_selbst_h,
    kf_erg_selbst_i,
    kf_erg_selbst_j,
    kf_erg_selbst_k,
    kf_erg_leistung_a,
    kf_erg_leistung_b,
    kf_erg_leistung_c,
    kf_erg_leistung_d,
    kf_erg_leistung_e,
    kf_erg_leistung_f,
    kf_erg_leistung_g,
    kf_erg_leistung_h,
    kf_erg_leistung_i,
    kf_erg_leistung_j,
    kf_erg_leistung_k,
    datum_cm_ende,
    art_cm_ende,
    abbruch_durch,
    gruende_abbruch_cm,
    veraenderung_inst_einbindung,
    ende_inst_einbindung,
    ziel1_erreicht,
    ziel2_erreicht,
    ziel3_erreicht,
    datum_verbleib_feststellung,
    verbleib_jugendliche,
    NULL::VARCHAR(60) AS verbleib_jugendliche_sonstiges FROM master_tbl_view;

-- master_tbl_anonym_insert_rule
CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

-- master_tbl_anonym_delete_rule
CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

-- master_tbl_eval_total_view;
CREATE OR REPLACE  VIEW master_tbl_eval_total_view AS
    SELECT m.* FROM master_tbl m JOIN ka_status_tbl s
        ON m.id = s.master_id
        WHERE
            s.status <> 3 AND
            (m.bearbeiter_id = (getuserid())::integer)
            OR pg_has_role('admin','MEMBER');

GRANT SELECT ON master_tbl_eval_total_view TO :cm_group;
GRANT SELECT ON master_tbl_eval_total_view TO :admin_group;

-- master_tbl_eval_incm_view;
CREATE OR REPLACE  VIEW master_tbl_eval_incm_view AS
    SELECT * FROM master_tbl_eval_total_view
        WHERE phase IN (2,3,4,5);

GRANT SELECT ON public.master_tbl_eval_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_eval_incm_view TO :admin_group;

-- master_tbl_incm_view
CREATE OR REPLACE  VIEW master_tbl_incm_view AS
    SELECT * FROM master_tbl_view
        WHERE phase IN (2,3,4,5);

GRANT SELECT ON public.master_tbl_incm_view TO :cm_group;
GRANT SELECT ON public.master_tbl_incm_view TO :admin_group;

COMMIT;
