## -*- coding: utf-8 -*- 
<%inherit file="../main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>

<div class="row">
  <div class="col-auto offset-1" id="content_ueberschrift">
    <h3>${_('Organisation')}</h3>
  </div>
  <div class="col modusfield">
    <%
       case_bundle = session.get('casebundle')
       if case_bundle:
           last_id = case_bundle.case_list[-1]
           overview_url = h.url(controller='case_overview', action='overview',
                                anchor=last_id)
       else:
           overview_url = h.url(controller='case_overview', action='overview')
    %>
    <a title="${_('Back to: Case document overview')}" href="${overview_url}">
      <svg class="svg-icon" aria-labelledby="title" role="img">
        <title id="title">${_('Back to: Case document overview')}</title>
        <use xlink:href="#arrow-circle-left" />
      </svg>
    </a>
  </div>
</div>


<div class="formularpage col-xl-9 offset-1">
  <p>${_('Please choose a new editor for the document')}:</p>
  <ul>
  % for case in c.case_list:
    <li>${case.last_name | F.NA}, ${case.first_name | F.NA}</li>
  % endfor
  </ul>
  % if h.hasRole(['admin']):
  <form action="${h.url(controller="case_bundle", action="set_editor")}" method="POST">
  ${ h.csrf_token() }
  
  <div class="form-group">
    <select name="editor" class="custom-select col-xl-3">
    % for user in c.user_list:
      <option value="${user.id | F.NA}">${user.last_name | F.NA} ${user.first_name | F.NA}</option>
    % endfor
    </select>
    <input class="btn btn-primary" type="submit" value="${_('Case document assigned')}">
  </div>
  </form>
  % endif
</div>
