## -*- coding: utf-8 -*-
<%! import mpulsweb.lib.helper.filters as F %>
<%inherit file="../main.mako" />

<%def name="title()">
    ${h.get_app_title()} - ${_('Helppage')}
</%def>

<div id="content_ueberschrift"><h3>${_('Helppage for %s') % h.get_app_title()}</h3></div>
% if g.mpuls_config.is_enabled('module', 'casemanagement'):
<h4 class="text-muted">${_('Case Management')}</h4>
<ul>
  <li>
    <strong>Pflichtfelder</strong>
    <p>
      In der Fallakte gibt es Pflichtfelder, die mit dem Sternchen-Symbol
      gekennzeichnet sind. Über das Phasenmodell (bei ausgewählter Fallakte
      unter > Überblick > Phase im CM) werden diese auch gelistet und sind
      verlinkt. Rote Felder bedeuten "relevant und noch nicht ausgefüllt",
      schwarze Felder bedeuten "nicht relevant oder bereits ausgefüllt".
    </p>
    <br>
  </li>
  <li>
    <strong>Regeln und Bedingungen</strong>
    <p>
      Einige Felder in der Fallakte sind mit <i>Regeln</i> und <i>Bedingungen</i> belegt, die
      nach dem Drücken des "Speichern"-Knopfes überprüft werden.<br>
    </p>
    </p>
      <i>Regeln</i> gibt es beispielsweise bei Datumsfeldern, die zueinander in
      Beziehung stehen.  Wenn hier Unregelmäßigkeiten auftauchen, werden diese
      (nach Drücken des "Speichern"-Knopfes überprüft und) auf der gleichen
      Folie als "Fehlerhafte Formulareingabe" angezeigt.<br>
    </p>
    <p>
      <i>Bedingungen</i> können Sie unter anderem daran erkennen, dass einige Felder
      ausgegraut und somit nicht bearbeitbar sind. Das heißt, es gibt Felder
      die erst im Verlauf relevant (vgl. unter 1. Pflichtfelder) für einen Fall
      werden.
    </p>
    <br>
  </li>
  <li>
    <strong>Einträge hinzufügen</strong>
    <p>
      In der Fallakte finden Sie an mehreren Stellen das Symbol mit einem
      Zettel und kleinem gelben Sternchen oder den Knopf "Erstelle neuen
      Eintrag". Hiermit können Sie flexibel weitere "Karteikarten" zu den
      verschiedenen Bereichen anlegen, wie z.B. zusätzliche Adressen, Kinder
      oder Förderpläne. Gelegentlich kann hier auch von sogenannten Repeat
      Groups (RG) die Rede sein.
    </p>
  </li>
</ul>
% endif
% if g.mpuls_config.is_enabled('module', 'evaluation'):
<h4 class="text-muted">${_('Evaluations')}</h4>
<ul>
  <li>
   <strong>1. Definition der auszuwertenden Fälle</strong>
   <p>Öffnen Sie die Agenturübersicht auf der linken Seite und definieren Sie
   einen Suchfilter, um nur ausgewählte Agenturen und über bestimmte Zeiträume
   oder andere Kriterien auszuwerten. Hierzu wählen Sie die Option "für
   Auswertung markieren" aus der Auswahlliste unterhalb der Agenturauflistung.</p>
   </li>
  <li>
   <strong>2. Auswahl und Definiton des Auswertungssatzes</strong>
   <p>Nachdem Sie den Suchfilter definiert haben, können Sie auf der linken
   Seite einen der verfügbaren Auswertungssätze auswählen. Bei der Auswahl
   öffnet sich eine neue Seite, die nocheinmal die gewählten Suchfilter zeigt.
   Einige von diesen können umdefiniert werden. Weiter können Sie auswählen,
   welche Einzelauswertungen innerhalb des Auswertungssatzes ausgewertet werden
   sollen. Beachten Sie, dass die Auswahl von nur wenigen Auswertungen eine
   signifikate Beschleunigung der Auswertung bedeuten kann.</p>
   </li>
  <li>
   <strong>3. Auswerten</strong>
   <p>Klicken Sie auf "Auswerten" nachdem Sie die Auswertungen ausgewählt
   haben, die Sie interessieren. Abhängig davon, wieviele Auswertungen gewählt
   wurden und der Anzahl der Fälle in der Datenbank, wird die Auswertung einige
   Zeit dauern. Ist die Auswertung abgeschlossen, wird eine Ergebnisseite
   angezeigt.</p>
   </li>
  <li>
   <strong>4. Exportieren (optional)</strong>
   <p>Wenn Sie die Ergebnisse der Auswertung in anderen Anwendungen
   weiterverwenden wollen, können Sie einen der verfügbaren Wege nutzen das
   Ergebnis zu exportieren. Ein Export einer XML oder CSV Datei kann über die
   entsprechenden Funktionen im oberen Teil der Seite durchgeführt werden. Eine
   weitere Möglichkeit zum Export ist die Daten per Kopieren/Einfügen direkt in
   eine Tabellenkalkulation einzufügen.</p>
   </li>
</ul>
% endif
<h4 class="text-muted">${_('Common help')}</h4>
<p>${h.literal(_('For further help please consult the documentation.'))}</p>
